<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:include href="dav.xsl"/>
<xsl:include href="dav_components.xsl"/>
<xsl:variable name="datasets" select="document('index:datasets')/xpml/resource[@name = $xpml/resource/@name]"/>
<xsl:variable name="ref"><xsl:value-of select="substring-before($request/get/ref, '.')"/><xsl:if test="substring-before($request/get/ref, '.') = ''"><xsl:value-of select="$request/get/ref"/></xsl:if></xsl:variable>

<xsl:template match="xpml" mode="options" priority="1">
<h3><xsl:value-of select="$labels/content/edit_index"/>: <xsl:value-of select="$xpml/meta/title"/><xsl:if test="substring-after($request/get/id, '.') != ''"><xsl:text> </xsl:text><xsl:value-of select="$labels/content/copy"/></xsl:if></h3>
<xsl:choose>
  <xsl:when test="$request/get/ref = 'new_record' and substring-after($request/get/id, '.') != ''">
    <h3><xsl:value-of select="$labels/content/edit_new_record"/></h3>
  </xsl:when>
  <xsl:when test="$request/get/ref = 'new_record'">
    <h3><xsl:value-of select="$labels/content/insert_record"/></h3>
  </xsl:when>
  <xsl:otherwise>
    <xsl:if test="not(substring-after($request/get/id, '.') != '') and not(normalize-space($read-only)= 'all') and not($request/get/merge != '')">
      <div class="options">
        <xsl:if test="meta/type='dataset' and not(contains($read-only, 'resource-content '))">
          <a href="{$action}&amp;ref=new_record"><xsl:value-of select="$labels/buttons/insert_record"/></a>
          <xsl:text></xsl:text>
        </xsl:if>
      </div>
    </xsl:if>
    <xsl:if test="not(substring-after($request/get/id, '.') != '') and normalize-space($read-only)= 'all' and not($request/get/merge != '')">
      <div class="options">
        <xsl:if test="meta/type='dataset' and not(contains($read-only, 'resource-content '))">
          <a href="{$action}&amp;ref=new_record"><xsl:value-of select="concat($labels/buttons/insert_record, ' ', $labels/content/copy)"/></a>
          <xsl:text></xsl:text>
        </xsl:if>
      </div>
    </xsl:if>
    <!--<xsl:if test="$request/get/merge != ''">
      <p><strong><xsl:value-of select="$labels/versions/merge"/></strong><br /><xsl:value-of select="$labels/versions/instructions"/> "<xsl:value-of select="$labels/buttons/save_merge"/>".</p>
    </xsl:if>-->
  </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="meta" mode="buttons" priority="1">
<xsl:if test="$request/get/ref != ''">
  <div>
    <xsl:if test="not(normalize-space($read-only) = 'all')">
      <xsl:choose>
        <xsl:when test="not($request/get/merge != '')">
          <input class="submitinput" type="button" value="{$labels/buttons/save}"  accesskey="s" onclick="pin_send(document.dav)" />
        </xsl:when>
        <xsl:otherwise>
          <input class="submitinput" type="button" value="{$labels/buttons/save_merge}" accesskey="s" onclick="pin_send(document.dav)" />
          <input class="submitinput" type="button" value="{$labels/buttons/dont_merge}" onclick="window.location.href='{$action}';" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <input class="submitinput" type="button" value="{$labels/buttons/save_copy}" onclick="document.dav.action = '{$script-name}?id={$xpml/meta/identifier[@type='id']}.{$ref}.{translate($date,'-T: ', '')}-{$user}&amp;ref={$ref}';pin_send(document.dav)" />
    <input class="submitinput" type="button" value="{$labels/buttons/close}" accesskey="w" onclick="window.location.href='{$script-name}?id={$xpml/meta/identifier[@type='id']}';" />
    <xsl:if test="$versions != '' and not(normalize-space($read-only) = 'all') and substring-after($request/get/id, '.') != ''">
      <input class="submitinput" type="button" value="{$labels/buttons/delete_copy}" onclick="doc_delete(document.dav,'{$labels/javascript/confirm_copy_delete}')" />
    </xsl:if>
    <xsl:if test="not(substring-after($request/get/id, '.') != '') and not(normalize-space($read-only) = 'all') and not($request/get/ref = 'new_record') and not($request/get/merge != '')">
      <input class="submitinput" type="button" value="{$labels/buttons/delete_record}" onclick="if(!confirm('{$labels/javascript/confirm_record_delete}')) return false;pin_todo.action='delete';pin_todo.param='[ref]';pin_send(document.dav);" style="margin-right: 0px;" />
    </xsl:if>
  </div>
</xsl:if>
<xsl:if test="not($request/get/ref != '')">
  <div>
    <xsl:if test="not(normalize-space($read-only) = 'all')">
      <input class="submitinput" type="button" value="{$labels/buttons/save}" accesskey="s" onclick="pin_send(document.dav)" />
    </xsl:if>
  <input class="submitinput" type="button" value="{$labels/buttons/close}" accesskey="w" onclick="window.location.href='{$action}&amp;close=1&amp;url={$base}/start';" />
  </div>
</xsl:if>

<textarea class="debug"><xsl:copy-of select="$request"/></textarea>
</xsl:template>

<xsl:template match="resource[@type='dataset']" mode="content" priority="1">
  <xsl:choose>
    <xsl:when test="$ref = current()/ref/@id">
      <xsl:apply-templates select="ref[@id = $request/get/ref]" mode="dataset-editing"/>
    </xsl:when>
    <xsl:when test="$request/get/ref = 'new_record'">
      <xsl:variable name="new-ref">
        <ref id="new_record"/>
      </xsl:variable>
      <div class="dataset">
        <xsl:apply-templates select="$new-ref/ref" mode="dataset-editing"/>
      </div>
    </xsl:when>
    <xsl:when test="contains(concat(' ', $versions, ' '), concat(' ', $request/get/id, '.', $request/get/ref, ' '))">
      <div class="dataset">
        <xsl:apply-templates select="document(concat($request/get/id, '/', $request/get/ref))/ref" mode="dataset-editing"/>
      </div>
    </xsl:when>
    <xsl:otherwise>
      <table cellpadding="0" cellspacing="0" border="0">
        <tbody>
          <tr class="tablerow">
            <xsl:for-each select="$datasets/ref//field[@listing-display = 'yes']">
              <th>
                <xsl:if test="position() = 1"><xsl:attribute name="class">first</xsl:attribute></xsl:if>
                <xsl:value-of select="label"/>
              </th>
            </xsl:for-each>
          </tr>
          <xsl:apply-templates select="ref" mode="dataset-listing">
            <xsl:sort />
          </xsl:apply-templates>
        </tbody>
      </table>
      <br />
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template mode="dataset-listing" match="ref">
  <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#fafffe';" class="tablerow">
    <xsl:variable name="ref" select="."/>
    <xsl:for-each select="$datasets/ref//field[@listing-display = 'yes']">
      <xsl:variable name="name" select="name"/>
      <td>
        <xsl:if test="position() = 1"><xsl:attribute name="class">first</xsl:attribute></xsl:if>
        <a href="{$script-name}?id={$request/get/id}&amp;ref={$ref/@id}">
          <xsl:apply-templates mode="list" select="$ref/*[name() = current()/name]/text()|$ref/*[name() = current()/name]/*[1]/text()"/>
        </a>
      </td>
    </xsl:for-each>
  </tr>
</xsl:template>

<xsl:template mode="version-control" match="*" priority="1">
<xsl:if test="$versions != ''">
  <div class="meta" style="background:none">
  <br />
  <h3><xsl:value-of select="$labels/versions/title"/></h3>
  <xsl:if test="$versions != ''">
    <p><xsl:value-of select="$labels/versions/record_copies"/></p>
    <table cellpadding="0" cellspacing="0" border="0" width="100%">
      <tbody>
        <tr>
          <th class="first"><xsl:value-of select="$labels/meta/identifier"/></th>
          <th><xsl:value-of select="$labels/meta/date_modified"/></th>
        </tr>
        <xsl:call-template name="index-version-details"><xsl:with-param name="v" select="normalize-space($versions)"/></xsl:call-template>
      </tbody>
    </table>
  </xsl:if>
  </div>
</xsl:if>
</xsl:template>

<xsl:template name="index-version-details">
  <xsl:param name="v"/>
  <xsl:param name="o"/>
  <xsl:if test="$v != ''">
    <xsl:variable name="id"><xsl:value-of select="substring-before($v, ' ')"/><xsl:if test="substring-before($v, ' ') = ''"><xsl:value-of select="$v"/></xsl:if></xsl:variable>
    <xsl:variable name="index" select="substring-before($id, '.')"/>
    <xsl:variable name="index-ref" select="substring-before(substring-after($id, '.'), '.')"/>
    <xsl:for-each select="document($id)/xpml/meta">
    <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#fafffe';" class="tablerow">
        <td class="first"><a href="{$script-name}?id={$id}&amp;ref={$index-ref}"><xsl:choose><xsl:when test="$index-ref != 'new_record'"><xsl:value-of select="$index-ref"/></xsl:when><xsl:otherwise><xsl:value-of select="$labels/buttons/new"/></xsl:otherwise></xsl:choose> (<xsl:value-of select="../resource/*[@id=$index-ref]/*[.!=''][1]"/>)</a></td>
        <td><a href="{$script-name}?id={$id}&amp;ref={$index-ref}"><xsl:apply-templates select="date[@type='modified']" mode="diff-date"/></a></td>
      <td style="vertical-align:middle"><a href="{$script-name}?id={identifier[@type='id']}&amp;merge={$id}&amp;ref={$index-ref}"><img src="{$base}/dav/images/dav_merge.gif" width="20px" height="11px" alt="{$labels/buttons/save_merge}" border="0" /></a></td>
    </tr>
    </xsl:for-each>
    <xsl:call-template name="index-version-details"><xsl:with-param name="v" select="normalize-space(substring-after($v, $id))"/></xsl:call-template>
  </xsl:if>
</xsl:template>

<xsl:template mode="dataset-editing" match="ref">
<xsl:param name="hide-id"/>
<xsl:param name="e" select="concat('x[', position(), '][ref]')"/>
<xsl:param name="datasets"><xsl:copy-of select="$datasets/*"/></xsl:param>
<xsl:param name="xpml-identifier" select="$xpml/meta/identifier[@type='id']"/>
<xsl:variable name="ref" select="."/>
<xsl:variable name="id">
  <xsl:choose>
  <xsl:when test="not(contains(@id, '#'))"><xsl:value-of select="concat($xpml-identifier, '#', @id)"/></xsl:when>
  <xsl:when test="contains(@id, '#latest')"><xsl:value-of select="concat(substring-before(@id, '#latest'), '#new_record')"/></xsl:when>
  <xsl:otherwise><xsl:value-of select="@id"/></xsl:otherwise>
  </xsl:choose>
</xsl:variable>
<div>
  <input type="hidden" name="{$e}[@id]" value="{$id}" />
  <xsl:if test="not(contains($id, '#new_record')) and $hide-id != 1">
    <p>
      <strong><xsl:value-of select="$labels/meta/identifier"/><xsl:text>: </xsl:text></strong>
      <xsl:value-of select="substring-after($id, '#')"/>
      <!--<xsl:if test="substring-after($request/get/ref, '.') != ''"><xsl:text> (</xsl:text><xsl:value-of select="$labels/versions/user_copy"/><em><xsl:value-of select="substring-after($request/get/ref, '.')"/></em>)</xsl:if>-->
    </p>
  </xsl:if>
  <xsl:apply-templates select="$datasets/ref/field|$datasets/ref/fieldset|$datasets/ref/inline" mode="dataset-editing">
    <xsl:with-param name="e" select="$e"/>
    <xsl:with-param name="ref" select="$ref"/>
  </xsl:apply-templates>
</div>
</xsl:template>

</xsl:stylesheet>