<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xml" omit-xml-declaration="yes"/>

<xsl:param name="read-only"/>
<xsl:param name="script-name"/>
<xsl:param name="request-uri"/>
<xsl:param name="referer"/>
<xsl:param name="referer-id"/>
<xsl:param name="dav-id"/>
<xsl:param name="user"/>
<xsl:param name="date"/>
<xsl:param name="base"/>
<xsl:variable name="request" select="document('arg:request')/request" />
<xsl:param name="msg" select="$request/get/msg"/>
<xsl:variable name="lc">abcdefghijklmnopqrstuvwxyz</xsl:variable>
<xsl:variable name="uc">ABCDEFGHIJKLMNOPQRSTUVWXYZ</xsl:variable>
<xsl:variable name="latin"> </xsl:variable>
<xsl:variable name="plain">_aaaaaeeeeiiiiooooouuuuc</xsl:variable>
<xsl:variable name="action"><xsl:value-of select="concat($script-name, '?id=', $request/get/id)"/><xsl:if test="$request/get/ref != ''"><xsl:value-of select="concat('&amp;ref=', $request/get/ref)"/></xsl:if></xsl:variable>
<xsl:variable name="users"   select="document('index:users')/xpml/resource[@name='users']"/>
<xsl:variable name="subject" select="document('index:subject')/xpml/resource[@name='subject']"/>
<xsl:variable name="uris"    select="document('index:uris')/xpml/resource[@name='uris']"/>
<xsl:variable name="sitemap" select="document('index:sitemap')/xpml/resource[@name='sitemap']"/>
<xsl:variable name="types"   select="document('arg:types')/types"/>
<xsl:variable name="labels"  select="document('arg:labels')/labels"/>
<xsl:variable name="rights"  select="document('arg:rights')/rights"/>
<xsl:variable name="type"    select="/xpml/meta/type"/>
<xsl:variable name="formats" select="document('arg:mime_types')/mime_types/*[name() = $type]"/>
<xsl:variable name="all-formats" select="document('arg:mime')/mime"/>
<xsl:variable name="lang"    select="document('arg:lang')/lang"/>
<xsl:param name="language" />
<xsl:variable name="turls"   select="document('arg:text-urls')/*"/>
<xsl:variable name="publishers" select="document('index:publishers')/xpml/resource[@name='publishers']"/>
<xsl:variable name="defaults" select="document('db:defaults')/xpml" />
<xsl:variable name="default-content" select="$defaults/resource[@type='content']"/>
<xsl:variable name="default-binary"  select="$defaults/resource[@type='binary']"/>
<xsl:variable name="xpml">
  <xsl:choose>
    <xsl:when test="$request/get/merge != ''">
      <xsl:variable name="o-meta"><xsl:copy-of select="/xpml/meta/identifier|/xpml/meta/format|/xpml/meta/relation|/xpml/meta/type"/></xsl:variable>
      <xsl:for-each select="document($request/get/merge)/xpml">
        <meta>
          <xsl:copy-of select="$o-meta/*"/>
          <xsl:copy-of select="meta/*[not(name()='identifier') and not(name()='format') and not(name()='relation') and not(name()='type')]"/>
        </meta>
        <xsl:copy-of select="*[not(name() = 'meta')]"/>
      </xsl:for-each>
    </xsl:when>
    <xsl:otherwise>
      <xsl:copy-of select="/xpml/*"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:variable>

<xsl:template match="/"><xsl:call-template name="header"/></xsl:template>

<xsl:template match="meta" mode="header">
  <meta http-equiv="content-type" content="text/html; encoding=iso-8859-1" />
  <title><xsl:value-of select="title"/></title>
  <link rel="stylesheet" href="{$base}/dav/styles/dav.css" type="text/css" />
  <style name="cssdyn" id="cssdyn" type="text/css"><xsl:text> </xsl:text></style>
  <script type="text/javascript" charset="iso-8859-1" src="{$base}/dav.js"><xsl:text> </xsl:text></script>
</xsl:template>

<xsl:template name="header">
<xsl:param name="show-header" select="1"/>
<xsl:if test="$referer-id != ''">
<style name="cssdyn" id="cssdyn" type="text/css">
#pindorama td, .toolbox_menu p { font-family: verdana, arial !important; font-size: 11px !important; text-align: left !important; padding: 0px !important; margin: 0px !important; line-height: 16px !important; }
#pindorama { background: #25402a; position: absolute; top: 0px; left: 0px;margin: 0px; z-index:1000; }
#pindoramactl { position: absolute; top: 0px !important; right: 5px;margin: 0px; z-index:1001 }
#pindoramactl a { color: #669966; cursor: pointer; text-decoration: none; font-weight: normal !important;}
#pindorama table { width:100%; height:5px}
#pindorama td { line-height: 20px; padding: 0px 16px 0px 8px; }
#pindorama td a { color: #ffffff; cursor: pointer; font-weight: normal !important; }
#pindorama p, .toolbox_menu p, .toolbox_menu h4  { margin: 0px 0px 8px 0px !important; }
.toolbox_menu {display:none;z-index:3; background: #25402a; padding: 5px 5px 0 5px;position:absolute;top:0px;left:0px;width:200px; border: 1px solid #339966}
.toolbox_menu a:link, .toolbox_menu a:visited { color: #ffffff; text-decoration: none; font-weight: normal !important; }
.toolbox_menu a:hover { color: #cccccc; text-decoration: underline; font-weight: normal !important;}
</style>
<div id="pindoramactl" name="pindoramactl"><a href="#" onclick="pin_change_visibility_persist('pindorama'); return false;">[]</a></div>
</xsl:if>
<div id="pindorama" name="pindorama">
<table cellpadding="0" border="0" cellspacing="0" summary="pindorama toolbox">
  <tr>
    <td style="width: 30%;">
      <xsl:if test="$show-header = 1">
      <a href="{$base}/start"><img src="{$base}/dav/images/pindorama.gif" width="100px" height="22px" border="0" alt="Pindorama" /></a>
      </xsl:if>
    </td>
    <xsl:if test="$show-header = 1">
    <td style="width: 70%">
      <a onclick="pin_show_menu('document_menu', this)"><xsl:value-of select="$labels/menu/docs"/></a>
      <xsl:text>|</xsl:text>
      <a onclick="pin_show_menu('index_menu', this)"><xsl:value-of select="$labels/menu/index"/></a>
      <xsl:text>|</xsl:text>
      <a onclick="pin_show_menu('tool_menu', this)"><xsl:value-of select="$labels/menu/tools"/></a>
      <xsl:text>|</xsl:text>
      <a onclick="pin_show_menu('user_menu', this)"><xsl:value-of select="$labels/menu/users"/></a>
      <!--<xsl:text>|</xsl:text>
      <a onclick="help()"><xsl:value-of select="$labels/menu/help"/></a>-->
    </td>
    </xsl:if>
  </tr>
</table>
</div>
<div id="document_menu" name="document_menu" class="toolbox_menu"><xsl:call-template name="menu-document"/></div>
<div id="index_menu" name="index_menu" class="toolbox_menu"><xsl:call-template name="menu-index"/></div>
<div id="tool_menu" name="tool_menu" class="toolbox_menu"><xsl:call-template name="menu-tool"/></div>
<div id="user_menu" name="user_menu" class="toolbox_menu"><xsl:call-template name="menu-user"/></div>
</xsl:template>

<xsl:template name="menu-document">
  <p><a href="{$base}/new.dav?id=db:new_{$user}"><xsl:value-of select="$labels/menu/docs_create"/></a></p>
  <p><a href="{$base}/open.dav"><xsl:value-of select="$labels/menu/docs_open"/></a></p>
  <p><a href="{$base}/publish.dav"><xsl:value-of select="$labels/menu/docs_publish"/></a></p>
  <xsl:choose>
    <xsl:when test="$referer-id != ''">
    <hr size="1" noshade="noshade" />
    <p><a href="{$base}/edit.dav?id={$referer-id}"><xsl:value-of select="$labels/menu/docs_open_this"/></a></p>
    <p><a href="{$base}/publish.dav?ids={$referer-id}"><xsl:value-of select="$labels/menu/docs_publish_this"/></a></p>
    </xsl:when>
    <xsl:otherwise>
    <hr size="1" noshade="noshade" />
    <p><a href="{$base}"><xsl:value-of select="$labels/menu/return_website"/></a></p>
    <xsl:if test="$xpml/meta/identifier[@type='url'] != ''">
      <p><a href="{$action}&amp;close=1&amp;url={$base}{$xpml/meta/identifier[@type='url']}"><xsl:value-of select="$labels/menu/docs_preview_this"/></a></p>
      <p><a href="{$action}&amp;close=1&amp;url={$base}/publish.dav?ids={$request/get/id}"><xsl:value-of select="$labels/menu/docs_publish_this"/></a></p>
    </xsl:if>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>
<xsl:template name="menu-index">
  <p><a href="{$base}/sitemap.dav"><xsl:value-of select="$labels/menu/index_sitemap"/></a></p>
  <p><a href="{$base}/uris.dav"><xsl:value-of select="$labels/menu/index_uris"/></a></p>
  <hr size="1" noshade="noshade" />
  <xsl:for-each select="document('index:datasets')/xpml/resource[@type='dataset-structure' and not(contains(@refx,'/')) and @display='yes']">
    <p><a href="{$base}/edit.dav?id={@ref}"><xsl:value-of select="title"/></a></p>
  </xsl:for-each>
</xsl:template>
<xsl:template name="menu-tool">
  <p><a href="{$base}/tools/docindex.dav"><xsl:value-of select="$labels/menu/tool_index_doc"/></a></p>
  <xsl:for-each select="document('arg:menu')/menu/tool/*">
    <xsl:sort select="position()" order="descending"/>
    <p><a href="{url}"><xsl:value-of select="label"/></a></p>
  </xsl:for-each>
</xsl:template> 
<xsl:template name="menu-user">
  <p><a href="{$base}/login.dav"><xsl:value-of select="$labels/menu/users_login"/></a></p>
  <p><a href="{$base}/login_cvs.dav"><xsl:value-of select="$labels/menu/users_batchlogin"/></a></p>
</xsl:template> 

</xsl:stylesheet>