<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- template de publicao das pginas do site pblico da RNP
     criado em 11/08/2003 por Guilherme Capil -->
 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:param name="title"/>
<xsl:param name="select"/>
<xsl:param name="insert"/>
<xsl:variable name="meta" select="/xpml/meta"/>
<xsl:include href="dav_header.xsl"/>

<xsl:param name="limit" select="25"/>

<xsl:template match="/">
<html>
  <head>
    <xsl:apply-templates select="$meta" mode="header"/>
    <link rel="stylesheet" href="{$base}/dav/styles/calendar-blue.css" type="text/css" />
    <script type="text/javascript" charset="iso-8859-1" src="{$base}/dav/scripts/calendar.js"><xsl:text> </xsl:text></script>
  </head>
  <body>
    <xsl:call-template name="header">
    </xsl:call-template>
    <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
    <div id="col123">
      <h1><xsl:value-of select="$labels/publish/title"/></h1>
      <form name="dav" action="{$script-name}" method="get">
      <table celpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td class="first">
            <p><xsl:value-of select="$labels/publish/for_approval"/></p>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <th class="first" style="width:50%"><xsl:value-of select="$labels/meta/url"/></th>
                <th style="width:40%"><xsl:value-of select="$labels/meta/date"/></th>
                <th style="width:50px"><xsl:value-of select="$labels/publish/options"/></th>
              </tr>
              <xsl:for-each select="xpml/resource/approval/line">
                <xsl:sort select="value[1]"/>
                <xsl:if test="position() &lt;= $limit">
                  <xsl:apply-templates select="." mode="pages" />
                </xsl:if>
              </xsl:for-each>
              <xsl:if test="not(xpml/resource/approval/line/value != '')">
                <tr><td class="first" colspan="3" style="color:#666666"><xsl:value-of select="$labels/publish/no_documents"/></td></tr>
              </xsl:if>
              <xsl:if test="count(xpml/resource/approval/line) &gt; $limit">
                <tr><td class="first" colspan="3" style="color:#666666">(+<xsl:value-of select="count(xpml/resource/approval/line) - $limit"/> <xsl:value-of select="$labels/publish/documents"/>)</td></tr>
              </xsl:if>
            </table>
            <br />
            <p><xsl:value-of select="$labels/publish/for_publishing"/></p>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <th class="first" style="width:50%"><xsl:value-of select="$labels/meta/url"/></th>
                <th style="width:40%"><xsl:value-of select="$labels/meta/date"/></th>
                <th style="width:50px"><xsl:value-of select="$labels/publish/options"/></th>
              </tr>
              <xsl:for-each select="xpml/resource/todo/line">
                <xsl:sort select="value[1]"/>
                <xsl:if test="position() &lt;= $limit">
                  <xsl:apply-templates select="." mode="pages" />
                </xsl:if>
              </xsl:for-each>
              <xsl:if test="count(xpml/resource/todo/line) &gt; $limit">
                <tr><td class="first" colspan="3" style="color:#666666">(+<xsl:value-of select="count(xpml/resource/todo/line) - $limit"/> <xsl:value-of select="$labels/publish/documents"/>)</td></tr>
              </xsl:if>
              <xsl:if test="not(xpml/resource/todo/line/value != '')">
                <tr><td class="first" colspan="3" style="color:#666666"><xsl:value-of select="$labels/publish/no_documents"/></td></tr>
              </xsl:if>
            </table>
            <br />
            <p><xsl:value-of select="$labels/publish/published"/></p>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <th class="first" style="width:50%"><xsl:value-of select="$labels/meta/url"/></th>
                <th style="width:40%"><xsl:value-of select="$labels/meta/date"/></th>
                <th style="width:50px"><xsl:value-of select="$labels/publish/options"/></th>
              </tr>
              <xsl:for-each select="xpml/resource/done/line">
                <xsl:sort select="value[1]" order="descending"/>
                <xsl:if test="position() &lt;= $limit">
                  <xsl:apply-templates select="." mode="pages" />
                </xsl:if>
              </xsl:for-each>
              <xsl:if test="not(xpml/resource/done/line/value != '')">
                <tr><td class="first" colspan="3" style="color:#666666"><xsl:value-of select="$labels/publish/no_documents"/></td></tr>
              </xsl:if>
            </table>
          </td>
          <td style="width:50%">
            <p><xsl:value-of select="$labels/publish/choose"/></p>
            <input type="hidden" name="start" value="1" />
            <label for="ids"><xsl:value-of select="$labels/meta/identifier"/><xsl:value-of select="$labels/publish/multiple"/></label>
            <br />
            <input type="text" name="ids" value="{normalize-space($request/get/ids)}" size="20" class="textinput" style="width:75%" />
            <input type="button" value="..." class="submitinput" onclick="pin_todo.action = 'document.dav.ids.value+=\' \'+';pin_choose_index('', 'sitemap-select')" style="width: 22%;" />
            <br />
            <input type="checkbox" name="ancestors" value="1000" /><xsl:text> </xsl:text>
            <label for="ancestors"><xsl:value-of select="$labels/publish/ancestors"/></label>
            <br />
            <input type="checkbox" name="descendants" value="1000" /><xsl:text> </xsl:text>
            <label for="descendants"><xsl:value-of select="$labels/publish/descendants"/></label>
            <br />
            <br />
            <label for="uris"><xsl:value-of select="$labels/meta/url"/><xsl:value-of select="$labels/publish/multiple"/></label>
            <br />
            <input type="text" name="uris" value="{normalize-space($request/get/uris)}" size="20" class="textinput" style="width:75%" />
            <input type="button" value="..." class="submitinput" onclick="pin_todo.action = 'document.dav.uris.value+=\' \'+';pin_choose_index('', 'uris-select')" style="width: 22%;" />
            <br />
            <br />
            <label for="when"><xsl:value-of select="$labels/publish/schedule"/></label>
            <br />
            <input required="yes" description="date" type="text" name="when" id="when" value="{$date}" class="textinput" style="width: 75%;" onchange="pin_check('date', this)" />
            <input type="button" value="..." class="submitinput" onclick="return showCalendar(this.previousSibling, 'y-mm-dd');" style="width: 22%;" />
            <br />
            <br />
            <br />
            <input type="button" class="submitinput" value="{$labels/buttons/publish}" onclick="return document.dav.submit();" />
          </td>
        </tr>
      </table>
      </form>
    </div>
  </body>
</html>
</xsl:template>

<xsl:template match="line[normalize-space(.) != '']" mode="pages">
  <xsl:variable name="parent">
    <xsl:if test="parent::done">done</xsl:if>
    <xsl:if test="parent::todo">todo</xsl:if>
    <xsl:if test="parent::approval">approval</xsl:if>
  </xsl:variable>
  <xsl:variable name="f" select="value[4]"/>
  <xsl:variable name="perm"><xsl:if test="document(concat('phpxml:check_permission:', value[3], ',publish'))/* = 1">ok</xsl:if></xsl:variable>
  <xsl:variable name="perm-a"><xsl:if test="document(concat('phpxml:check_permission:', value[3], ',write'))/* = 1">ok</xsl:if></xsl:variable>
  <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#fafffe';" class="tablerow">
    <td class="first"><a href="{value[4]}"><xsl:value-of select="value[4]"/></a></td>
    <td><xsl:apply-templates select="value[1]" mode="date" /></td>
    <td>
      <xsl:if test="$perm-a = 'ok' and value[3] != 'none'">
        <a href="{$base}/edit.dav?id={value[3]}"><img class="icon" src="{$base}/dav/images/dav_edit.gif" alt="{$labels/buttons/edit}" border="0" width="11" height="11" /></a>
      </xsl:if>
      <a href="{value[4]}"><img class="icon" src="{$base}/dav/images/dav_goto.gif" alt="{$labels/buttons/preview}" border="0" width="11" height="11" /></a>
      <xsl:if test="$perm = 'ok'">
        <xsl:if test="parent::done">
          <a href="{$script-name}?uris={value[4]}&amp;start=1" onclick="document.dav.uris.value += '{value[4]} '; return false;">
            <img class="icon" src="{$base}/dav/images/dav_publish.gif" alt="{$labels/buttons/publish}" border="0" width="11" height="11" /> 
          </a>
        </xsl:if>
        <xsl:if test="not(parent::done)">
          <a href="{$script-name}?delete[{$parent}]={value[4]}@{value[1]}&amp;uris=/{value[4]}&amp;start=1">
            <img class="icon" src="{$base}/dav/images/dav_publish.gif" alt="{$labels/buttons/publish}" border="0" width="11" height="11" /> 
          </a>
        </xsl:if>
      </xsl:if>
      <xsl:if test="$perm = 'ok' and not(parent::done)">
          <a href="{$script-name}?delete[{$parent}]={value[4]}@{value[1]}&amp;start=1" onclick="return confirm('{$labels/publish/confirm_delete}');">
            <img class="icon" src="{$base}/dav/images/delete.gif" alt="apagar publicao" border="0" width="10" height="10" />
          </a>
      </xsl:if>
    </td> 
  </tr>
</xsl:template>


<xsl:template match="value" mode="date">
<xsl:if test="concat(substring(., 1, 4),'-', substring(., 5, 2), '-', substring(., 7, 2)) != substring($date, 1, 10)"><xsl:value-of select="concat(substring(., 7, 2), '.', substring(., 5, 2), '.', substring(., 1, 4))"/>&#160;</xsl:if>
<xsl:value-of select="concat(substring(., 9, 2), ':', substring(., 11, 2))"/>
</xsl:template>
</xsl:stylesheet>
