<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:param name="title"/>
<xsl:param name="select"/>
<xsl:param name="insert"/>
<xsl:variable name="meta">
  <meta>
  <title><xsl:value-of select="$title"/></title>
  </meta>
</xsl:variable>
<xsl:include href="dav_header.xsl"/>
<xsl:variable name="dir"><xsl:value-of select="normalize-space($request/get/dir)"/><xsl:if test="substring(normalize-space($request/get/dir), string-length(normalize-space($request/get/dir))) != '/'">/</xsl:if></xsl:variable>


<xsl:template match="/">
<xsl:variable name="show-header"><xsl:if test="not($select = 1 or $insert = 1)">1</xsl:if></xsl:variable>
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body style="border: 1px solid #116644; background: #eaefee;width:98%;">
    <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
    <table cellpadding="0" cellspacing="0" border="0" width="198px" style="padding: 0px; margin: 0px;background: #eaefee;">
      <xsl:apply-templates select="/xpml/resource/*"><xsl:sort select="translate(., '_-.', ' ')"/></xsl:apply-templates>
    </table>
  </body>
</html>
</xsl:template>

<xsl:template match="*">
  <xsl:variable name="value"><xsl:value-of select="*[normalize-space(.) != ''][1]"/><xsl:if test="not(*[normalize-space(.) != ''][1])"><xsl:value-of select="."/></xsl:if></xsl:variable>
  <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#eaefee';" class="tablerow">
    <td width="13px">
      <a href="#" onclick="parent.pin_todo.param = '{$value}'; parent.pin_do_todo(); parent.focus();parent.pin_hide_listings();"><img src="{$base}/dav/images/dav_select.gif" width="11" height="11" alt="{$labels/buttons/select}" border="0" /></a>
    </td>
    <td>
      <a href="#" onclick="parent.pin_todo.param = '{$value}'; parent.pin_do_todo(); parent.focus();parent.pin_hide_listings();"><xsl:value-of select="substring($value, 1, 20)"/><xsl:if test="string-length($value) &gt; 20">&#133;</xsl:if></a>
    </td>
  </tr>
</xsl:template>

<xsl:template match="uri">
  <xsl:variable name="value"><xsl:value-of select="*[normalize-space(.) != ''][1]"/><xsl:if test="not(*[normalize-space(.) != ''][1])"><xsl:value-of select="."/></xsl:if></xsl:variable>
  <xsl:variable name="subdir">/<xsl:value-of select="substring-before(substring-after($value, concat($request/get/dir, '/')), '/')"/></xsl:variable>
  <xsl:if test="position() = 1">
    <xsl:variable name="prevdir"><xsl:call-template name="last-substring-before"><xsl:with-param name="string" select="$request/get/dir"/><xsl:with-param name="needle" select="'/'"/></xsl:call-template></xsl:variable>
      <tr onMouseOver="this.bgColor='#99aa9a';" onMouseOut="this.bgColor='#aabbab';" class="tablerow" style="background:#aabbab">
      <td width="13px">
        <img src="{$base}/dav/images/dir.gif" width="14" height="13" alt="{$labels/icons/dir}" border="0" />
      </td>
      <td>
        <!--<a href="{$script-name}?index={$request/get/index}&amp;dir={$prevdir}"><xsl:value-of select="$request/get/dir"/>/</a>-->
        <xsl:call-template name="r-dir">
          <xsl:with-param name="dir" select="$request/get/dir" />
          <xsl:with-param name="uri" select="concat($script-name, '?index=', $request/get/index, '&amp;dir=')" />
        </xsl:call-template>

      </td>
    </tr>
  </xsl:if>
  <xsl:if test="substring-after($value, $request/get/dir) != ''">
    <xsl:choose>
      <xsl:when test="$subdir != '/' and not(preceding-sibling::uri[contains(., concat($request/get/dir, $subdir))])">
        <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#eaefee';" class="tablerow">
          <td width="13px">
            <xsl:text> </xsl:text>
          </td>
          <td>
            <a href="{$script-name}?index={$request/get/index}&amp;dir={$request/get/dir}{$subdir}"><xsl:value-of select="substring($subdir, 1, 20)"/><xsl:if test="string-length($subdir) &gt; 20">&#133;</xsl:if></a>
          </td>
        </tr>
      </xsl:when>
      <xsl:when test="$subdir = '/' and not(contains(substring-after(., concat($dir, '/')), '/'))">
        <xsl:variable name="filename" select="substring-after(., $request/get/dir)"/>
        <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#eaefee';" class="tablerow">
          <td width="13px">
            <a href="#" onclick="parent.pin_todo.param = '{$value}'; parent.pin_do_todo(); parent.focus();parent.pin_hide_listings();"><img src="{$base}/dav/images/dav_select.gif" width="11" height="11" alt="{$labels/buttons/select}" border="0" /></a>
          </td>
          <td>
            <a href="#" onclick="parent.pin_todo.param = '{$value}'; parent.pin_do_todo(); parent.focus();parent.pin_hide_listings();"><xsl:value-of select="substring($filename, 1, 20)"/><xsl:if test="string-length($filename) &gt; 20">&#133;</xsl:if></a>
          </td>
        </tr>
      </xsl:when>
    </xsl:choose>
    
  </xsl:if>
</xsl:template>

<xsl:template name="last-substring-before">
<xsl:param name="string"/>
<xsl:param name="needle"/>
<xsl:value-of select="substring-before($string, $needle)"/>
<xsl:if test="$string != '' and $needle != '' and contains(substring-after($string, $needle), $needle)">
  <xsl:value-of select="concat($needle, substring-before(substring-after($string, $needle), $needle))"/>
  <xsl:call-template name="last-substring-before">
    <xsl:with-param name="string" select="concat($needle, substring-after(substring-after($string, $needle), $needle))"/>
    <xsl:with-param name="needle" select="$needle"/>
  </xsl:call-template>
</xsl:if>
</xsl:template>

<xsl:template name="r-dir">
<xsl:param name="r-dir" select="'/'" />
<xsl:param name="dir" select="$request/get/dir" />
<xsl:param name="uri" select="concat($script-name, '?dir=')" />
<xsl:if test="$r-dir = '/'"><a href="{$uri}"><xsl:value-of select="$labels/sitemap/root"/>/</a><xsl:text> </xsl:text></xsl:if>
<xsl:if test="$r-dir != $dir">
  <xsl:variable name="nr-dir" select="substring-after($dir, $r-dir)"/>
  <xsl:choose>
    <xsl:when test="substring-after($nr-dir, '/') != ''">
      <a href="{$uri}{$r-dir}{substring-before($nr-dir, '/')}"><xsl:value-of select="substring-before($nr-dir, '/')"/>/</a>
      <xsl:call-template name="r-dir"><xsl:with-param name="r-dir" select="concat($r-dir, substring-before($nr-dir, '/'), '/')"/></xsl:call-template>
    </xsl:when>
    <xsl:when test="$nr-dir != ''">
      <xsl:value-of select="$nr-dir"/>
    </xsl:when>
  </xsl:choose>
</xsl:if>
</xsl:template>

</xsl:stylesheet>