<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:include href="dav_header.xsl"/>
<xsl:variable name="meta">
  <meta>
  <title><xsl:value-of select="$labels/login/page_title"/></title>
  </meta>
</xsl:variable>


<xsl:template match="/">
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body>
  <xsl:call-template name="header"/>
  <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
  <div id="col23">
    <form name="dav" submit-encoding="iso-8859-1" method="post" action="{$request-uri}" onsubmit="return pin_send(document.dav);">
      <h3><xsl:value-of select="$labels/login/user"/>: <xsl:value-of select="$user"/></h3>
      <div class="options">
        <a href="{$script-name}?action=logout"><xsl:value-of select="$labels/login/logout"/></a>
        <xsl:text></xsl:text>
        <a><xsl:if test="normalize-space($request/get/edit) != 'info'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit=info</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_info"/></a>
        <xsl:text></xsl:text>
        <a><xsl:if test="normalize-space($request/get/edit) != 'password'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit=password</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_password"/></a>
      </div>
      <div style="width:50%">
        <xsl:apply-templates select="xpml/resource[@name = 'users']/user[login = $user]"/>
      </div>
    </form>
  </div>
  </body>
</html>
</xsl:template>

<xsl:template match="meta">
<div class="meta">
<p><xsl:value-of select="title"/></p>
</div>
</xsl:template>

<xsl:template match="user">
  <xsl:choose>
    <xsl:when test="normalize-space($request/get/edit) = 'info'">
      <p><label for="user[name]"><xsl:value-of select="$labels/meta/name"/></label><br /><input type="text" class="textinput" name="user[name]" value="{name}"/></p>
      <p><label for="user[email]"><xsl:value-of select="$labels/meta/email"/></label><br /><input type="text" class="textinput" name="user[email]" value="{email}"/></p>
      <p>
        <label for="user[wysiwyg-editor]"><xsl:value-of select="$labels/login/use_wysiwyg"/></label>
        <br />
        <input type="checkbox" class="checkinput" name="user[wysiwyg-editor]" value="yes">
          <xsl:if test="wysiwyg-editor = 'yes'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
        </input>
      </p>
      <br />
      <p><label for="password"><xsl:value-of select="$labels/login/password_confirm"/></label><br /><input type="password" class="textinput" name="password" value=""/></p>
      <p>
        <input class="submitinput" type="button" value=" {$labels/buttons/save} " accesskey="s" onclick="document.dav.submit()" />
        <xsl:text></xsl:text>
        <input class="submitinput" type="button" value=" {$labels/buttons/close} " accesskey="x" onclick="window.location.href=window.location.pathname;" />
      </p>
    </xsl:when>
    <xsl:when test="normalize-space($request/get/edit) = 'password'">
      <p><xsl:value-of select="$labels/meta/name"/><br /><xsl:value-of select="name"/></p>
      <p><xsl:value-of select="$labels/meta/email"/><br /><xsl:value-of select="email"/></p>
      <br />
      <p><label for="password"><xsl:value-of select="$labels/login/password_new"/></label><br /><input type="password" class="textinput" name="password-update" value=""/></p>
      <p><label for="password"><xsl:value-of select="$labels/login/password_new_confirm"/></label><br /><input type="password" class="textinput" name="password-update-confirm" value=""/></p>
      <br />
      <p><label for="password"><xsl:value-of select="$labels/login/password_confirm"/></label><br /><input type="password" class="textinput" name="password" value=""/></p>
      <p>
        <input class="submitinput" type="button" value=" {$labels/buttons/save} " accesskey="s" onclick="document.dav.submit()" />
        <xsl:text></xsl:text>
        <input class="submitinput" type="button" value=" {$labels/buttons/close} " accesskey="x" onclick="window.location.href = window.location.pathname;" />
      </p>
    </xsl:when>
    <xsl:otherwise>
      <p><xsl:value-of select="$labels/meta/name"/><br /><xsl:value-of select="name"/></p>
      <p><xsl:value-of select="$labels/meta/email"/><br /><xsl:value-of select="email"/></p>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="user" mode="users">
  <div name="users_{position()}" id="users_{position()}">
  <p>
    <label for="users[{position()}][user][name]"><xsl:value-of select="$labels/meta/name"/> </label>
    <input class="textinput" type="text" name="users[{position()}][user][name]" value="{name}" />
  </p>
  <p>
    <label for="users[{position()}][user][email]"><xsl:value-of select="$labels/meta/name"/> </label>
    <input class="textinput" type="text" name="users[{position()}][user][email]" value="{email}" />
  </p>
  </div>
</xsl:template>

</xsl:stylesheet>