<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xml" omit-xml-declaration="yes"/>

<xsl:variable name="permissions" select="document('arg:permissions')/xpml"/>

<xsl:include href="dav_header.xsl"/>
<xsl:variable name="icon"><img src="{$base}/dav/images/seta.gif" width="9" height="9" border="0" alt="{$labels/buttons/edit}" style="vertical-align: middle; text-align: right; margin-right: 5px;" /></xsl:variable>
<xsl:variable name="meta">
  <meta>
    <title><xsl:value-of select="$labels/login/page_title"/></title>
  </meta>
</xsl:variable>

<xsl:template match="/">
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body>
  <xsl:call-template name="header"/>
  <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
  <div id="col1">
    <div class="meta">
    <h3><xsl:value-of select="$labels/login/existing_users"/></h3>
    <div class="options">
      <a><xsl:if test="normalize-space($request/get/edit-user) != 'new'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit-user=new</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/insert"/></a>
      <xsl:text></xsl:text>
      <a><xsl:if test="normalize-space($request/get/edit-user) != 'delete'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit-user=delete</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/delete"/></a>
      <xsl:text></xsl:text>
      <a href="/login_cvs.dav"><xsl:value-of select="$labels/login/cvs"/></a>
    </div>
    <table cellpadding="0" cellspacing="0" border="0">
      <tr>
        <th class="first">
          <p><xsl:value-of select="$labels/meta/login"/></p>
        </th>
        <th>
          <p></p>
        </th>
        <th>
          <p><xsl:value-of select="$labels/meta/name"/></p>
        </th>
      </tr>
      <xsl:for-each select="xpml/resource[@name = 'users']/user">
        <xsl:sort select="login"/>
        <tr>
          <td class="first">
            <p><xsl:value-of select="login"/></p>
          </td>
          <td>
            <p><a href="{$script-name}?user={login}"><xsl:copy-of select="$icon/*"/></a></p>
          </td>
          <td>
            <p><xsl:value-of select="name"/></p>
          </td>
        </tr>
      </xsl:for-each>
    </table>
    <br />
    <h3><xsl:value-of select="$labels/login/existing_groups"/></h3>
    <div class="options">
      <a><xsl:if test="normalize-space($request/get/edit-group) != 'new'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit-group=new</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/insert"/></a>
      <xsl:text></xsl:text>
      <a><xsl:if test="normalize-space($request/get/edit-group) != 'delete'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit-group=delete</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/delete"/></a>
    </div>
    <table cellpadding="0" cellspacing="0" border="0">
      <tr>
        <th class="first">
          <p><xsl:value-of select="$labels/meta/name"/></p>
        </th>
        <th>
          <p></p>
        </th>
        <th>
          <p><xsl:value-of select="$labels/login/users"/></p>
        </th>
      </tr>
      <xsl:for-each select="$permissions/resource[@name='groups']/*">
        <xsl:sort select="name()"/>
        <tr>
          <td class="first">
            <p><xsl:value-of select="name()"/></p>
          </td>
          <td>
            <p><a href="{$script-name}?group={name()}"><xsl:copy-of select="$icon/*"/></a></p>
          </td>
          <td>
            <p><xsl:value-of select="."/></p>
          </td>
        </tr>
      </xsl:for-each>
    </table>
    <br />
    <h3><xsl:value-of select="$labels/login/existing_permissions"/></h3>
    <div class="options">
      <a><xsl:if test="normalize-space($request/get/edit-permissions) != 'new'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit-permissions=new</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/insert"/></a>
      <xsl:text></xsl:text>
      <a><xsl:if test="normalize-space($request/get/edit-permissions) != 'delete'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit-permissions=delete</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/delete"/></a>
    </div>
    <table cellpadding="0" cellspacing="0" border="0">
      <tr>
        <th class="first">
          <p><xsl:value-of select="$labels/login/rules"/></p>
        </th>
        <th>
          <p></p>
        </th>
        <th>
          <p><xsl:value-of select="$labels/login/permission"/></p>
        </th>
      </tr>
      <xsl:for-each select="$permissions/resource[@name='permissions']/*">
        <tr>
          <td class="first">
            <p><xsl:value-of select="url"/></p>
          </td>
          <td>
            <p><a href="{$script-name}?permission={position()}"><xsl:copy-of select="$icon/*"/></a></p>
          </td>
          <td>
            <p>
              <xsl:for-each select="grp">
                <xsl:if test="position() =1"><xsl:value-of select="$labels/login/groups"/>: </xsl:if>
                <xsl:value-of select="."/>
              </xsl:for-each>
              <xsl:if test="grp and usr"><br /></xsl:if>
              <xsl:for-each select="usr">
                <xsl:if test="position() =1"><xsl:value-of select="$labels/login/users"/>: </xsl:if>
                <xsl:value-of select="."/>
              </xsl:for-each>
            </p>
          </td>
        </tr>
      </xsl:for-each>
    </table>
    </div>
  </div>
  <div id="col23">
    <form name="dav" submit-encoding="iso-8859-1" method="post" action="{$request-uri}" onsubmit="return pin_send(document.dav);">
      <h3><xsl:value-of select="$labels/login/user"/>: <xsl:value-of select="$user"/></h3>
      <xsl:choose>
        <!-- novo usurio -->
        <xsl:when test="normalize-space($request/get/edit-user) = 'new'">
          <h3><xsl:value-of select="$labels/login/insert_user"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="{$request/get/edit-user}"/>
            <p><label for="login"><xsl:value-of select="$labels/meta/login"/></label><br /><input type="text" class="textinput" name="login" value=""/></p>
            <p><label for="user[name]"><xsl:value-of select="$labels/meta/name"/></label><br /><input type="text" class="textinput" name="user[name]" value=""/></p>
            <p><label for="user[email]"><xsl:value-of select="$labels/meta/email"/></label><br /><input type="text" class="textinput" name="user[email]" value=""/></p>
            <p>
              <label for="user[wysiwyg-editor]"><xsl:value-of select="$labels/login/use_wysiwyg"/></label>
              <br />
              <input type="checkbox" class="checkinput" name="user[wysiwyg-editor]" value="yes">
                <xsl:if test="wysiwyg-editor = 'yes'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
              </input>
            </p>
            <p><label for="password"><xsl:value-of select="$labels/login/password_new"/></label><br /><input type="password" class="textinput" name="password-update" value=""/></p>
            <p><label for="password"><xsl:value-of select="$labels/login/password_new_confirm"/></label><br /><input type="password" class="textinput" name="password-update-confirm" value=""/></p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <!-- novo grupo -->
        <xsl:when test="normalize-space($request/get/edit-group) = 'new'">
          <h3><xsl:value-of select="$labels/login/insert_group"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="{$request/get/edit-group}-group"/>
            <p><label for="login"><xsl:value-of select="$labels/meta/name"/></label><br /><input type="text" class="textinput" name="login" value=""/></p>
            <p><label for="users[]"><xsl:value-of select="$labels/login/users"/></label><br />
              <select name="users[]" id="users[]" multiple="multiple" class="textinput" size="4">
                <xsl:for-each select="xpml/resource[@name = 'users']/user">
                  <option value="{login}"><xsl:value-of select="login"/></option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <xsl:when test="normalize-space($request/get/edit-permissions) = 'new'">
          <h3><xsl:value-of select="$labels/login/insert_rule"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="new-permission"/>
            <p><label for="url"><xsl:value-of select="$labels/login/rule"/></label><br /><input type="text" class="textinput" name="url" value=""/></p>
            <p><label for="users[]"><xsl:value-of select="$labels/login/users"/></label><br />
              <select name="users[]" id="users[]" multiple="multiple" class="textinput" size="4">
                <xsl:for-each select="xpml/resource[@name = 'users']/user">
                  <option value="{login}"><xsl:value-of select="login"/></option>
                </xsl:for-each>
              </select>
            </p>
            <p><label for="groups[]"><xsl:value-of select="$labels/login/groups"/></label><br />
              <select name="groups[]" id="groups[]" multiple="multiple" class="textinput" size="4">
                <xsl:for-each select="$permissions/resource[@name='groups']/*">
                  <xsl:sort select="name()"/>
                  <option value="{name()}"><xsl:value-of select="name()"/></option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <xsl:when test="normalize-space($request/get/edit-user) = 'delete'">
          <h3><xsl:value-of select="$labels/login/delete_user"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="{$request/get/edit-user}"/>
            <p><label for="login"><xsl:value-of select="$labels/meta/login"/></label>
              <br />
              <select name="login" id="login" class="textinput">
                <xsl:for-each select="xpml/resource[@name = 'users']/user">
                  <option value="{login}"><xsl:value-of select="login"/></option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <xsl:when test="normalize-space($request/get/edit-group) = 'delete'">
          <h3><xsl:value-of select="$labels/login/delete_group"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="delete-group"/>
            <p>
              <label for="login"><xsl:value-of select="$labels/meta/name"/></label>
              <br />
              <select name="login" id="login" class="textinput">
                <xsl:for-each select="$permissions/resource[@name='groups']/*">
                  <xsl:sort select="name()"/>
                  <option value="{name()}"><xsl:value-of select="name()"/></option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <xsl:when test="normalize-space($request/get/edit-permissions) = 'delete'">
          <xsl:variable name="edit-permission" select="$permissions/resource[@name='permissions']/*[position() = $request/get/permission]"/>
          <h3><xsl:value-of select="$labels/login/delete_rule"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="delete-permission"/>
            <p><label for="url"><xsl:value-of select="$labels/login/rule"/></label><br />
              <select name="url" id="url" class="textinput">
                <xsl:for-each select="$permissions/resource[@name='permissions']/*">
                  <option value="{url}">
                    <xsl:value-of select="url"/>
                  </option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <!-- atualizao do usurio -->
        <xsl:when test="normalize-space($request/get/user) != ''">
          <h3><xsl:value-of select="$labels/login/edit_user"/>: <xsl:value-of select="$request/get/user"/></h3>
          <div class="options">
            <a><xsl:if test="$request/get/edit"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?user=<xsl:value-of select="normalize-space($request/get/user)"/></xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_info"/></a>
            <xsl:text></xsl:text>
            <a><xsl:if test="normalize-space($request/get/edit) != 'password'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?user=<xsl:value-of select="normalize-space($request/get/user)"/>&amp;edit=password</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_password"/></a>
            <xsl:text></xsl:text>
            <a><xsl:if test="normalize-space($request/get/edit) != 'group'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?user=<xsl:value-of select="normalize-space($request/get/user)"/>&amp;edit=group</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_group"/></a>
          </div>
          <input type="hidden" name="login" value="{$request/get/user}"/>
          <div style="width:50%">
            <xsl:apply-templates select="xpml/resource[@name = 'users']/user[login = $request/get/user]"/>
          </div>
        </xsl:when>
        <xsl:when test="normalize-space($request/get/group) != '' and $permissions/resource[@name='groups']/*[name() = $request/get/group]">
          <xsl:variable name="group-users" select="concat(' ', $permissions/resource[@name='groups']/*[name() = $request/get/group], ' ')"/>
          <h3><xsl:value-of select="$labels/login/edit_group"/>: <xsl:value-of select="$request/get/group"/></h3>
          <div style="width:50%">
            <input type="hidden" name="edit-action" value="edit-group"/>
            <input type="hidden" name="login" value="{$request/get/group}"/>
            <p><label for="users[]"><xsl:value-of select="$labels/login/users"/></label><br />
              <select name="users[]" id="users[]" multiple="multiple" class="textinput" size="4">
                <xsl:for-each select="xpml/resource[@name = 'users']/user">
                  <option value="{login}">
                    <xsl:if test="contains($group-users, concat(' ', login, ' '))">
                      <xsl:attribute name="selected">selected</xsl:attribute>
                    </xsl:if>
                    <xsl:value-of select="login"/>
                  </option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <xsl:when test="normalize-space($request/get/permission) != ''">
          <xsl:variable name="edit-permission" select="$permissions/resource[@name='permissions']/*[position() = $request/get/permission]"/>
          <h3><xsl:value-of select="$labels/login/edit_rule"/></h3>
          <div style="width:50%">
            <input type="hidden" name="rule" value="{$request/get/permission -1}"/>
            <input type="hidden" name="edit-action" value="edit-permission"/>
            <p><label for="url"><xsl:value-of select="$labels/login/rule"/></label><br /><input type="text" class="textinput" name="url" value="{$edit-permission/url}"/></p>
            <p><label for="users[]"><xsl:value-of select="$labels/login/users"/></label><br />
              <select name="users[]" id="users[]" multiple="multiple" class="textinput" size="4">
                <xsl:for-each select="xpml/resource[@name = 'users']/user">
                  <option value="{login}">
                    <xsl:if test="contains(concat(' ', $edit-permission/usr, ' '), concat(' ', login, ' '))">
                      <xsl:attribute name="selected">selected</xsl:attribute>
                    </xsl:if>
                    <xsl:value-of select="login"/>
                  </option>
                </xsl:for-each>
              </select>
            </p>
            <p><label for="groups[]"><xsl:value-of select="$labels/login/groups"/></label><br />
              <select name="groups[]" id="groups[]" multiple="multiple" class="textinput" size="4">
                <xsl:for-each select="$permissions/resource[@name='groups']/*">
                  <xsl:sort select="name()"/>
                  <option value="{name()}">
                    <xsl:if test="contains(concat(' ', $edit-permission/grp, ' '), concat(' ', name(), ' '))">
                      <xsl:attribute name="selected">selected</xsl:attribute>
                    </xsl:if>
                    <xsl:value-of select="name()"/>
                  </option>
                </xsl:for-each>
              </select>
            </p>
            <xsl:call-template name="submit-buttons"/>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div class="options">
            <a href="{$script-name}?action=logout"><xsl:value-of select="$labels/login/logout"/></a>
            <xsl:text></xsl:text>
            <a><xsl:if test="normalize-space($request/get/edit) != 'info'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit=info</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_info"/></a>
            <xsl:text></xsl:text>
            <a><xsl:if test="normalize-space($request/get/edit) != 'password'"><xsl:attribute name="href"><xsl:value-of select="$script-name"/>?edit=password</xsl:attribute></xsl:if><xsl:value-of select="$labels/login/change_password"/></a>
          </div>
          <div style="width:50%">
            <xsl:apply-templates select="xpml/resource[@name = 'users']/user[login = $user]"/>
          </div>
        </xsl:otherwise>
      </xsl:choose>
    </form>
  </div>
  </body>
</html>
</xsl:template>

<xsl:template match="meta">
<div class="meta">
<p><xsl:value-of select="title"/></p>
</div>
</xsl:template>

<!-- alterao do usurio -->
<xsl:template match="user">
  <xsl:choose>
    <xsl:when test="normalize-space($request/get/edit) = 'password'">
      <p><xsl:value-of select="$labels/meta/name"/><br /><xsl:value-of select="name"/></p>
      <p><xsl:value-of select="$labels/meta/email"/><br /><xsl:value-of select="email"/></p>
      <br />
      <p><label for="password"><xsl:value-of select="$labels/login/password_new"/></label><br /><input type="password" class="textinput" name="password-update" value=""/></p>
      <p><label for="password"><xsl:value-of select="$labels/login/password_new_confirm"/></label><br /><input type="password" class="textinput" name="password-update-confirm" value=""/></p>
      <xsl:call-template name="submit-buttons"/>
    </xsl:when>
    <xsl:when test="normalize-space($request/get/edit) = 'group'">
      <xsl:variable name="login" select="login"/>
      <p><xsl:value-of select="$labels/meta/name"/><br /><xsl:value-of select="name"/></p>
      <p><xsl:value-of select="$labels/meta/email"/><br /><xsl:value-of select="email"/></p>
      <br />
      <input type="hidden" name="edit-action" value="edit-usergroups"/>
      <p><label for="usergroups[]"><xsl:value-of select="$labels/login/groups"/></label><br />
        <select name="usergroups[]" id="usergroups[]" multiple="multiple" class="textinput" size="4">
          <xsl:for-each select="$permissions/resource[@name='groups']/*">
            <xsl:sort select="name()"/>
            <option value="{name()}">
              <xsl:if test="contains(concat(' ', ., ' '), concat(' ', $login, ' '))">
                <xsl:attribute name="selected">selected</xsl:attribute>
              </xsl:if>
              <xsl:value-of select="name()"/>
            </option>
          </xsl:for-each>
        </select>
      </p>
      <xsl:call-template name="submit-buttons"/>
    </xsl:when>
    <xsl:when test="normalize-space($request/get/edit) = 'info' or normalize-space($request/get/user) = login">
      <p><label for="user[name]"><xsl:value-of select="$labels/meta/name"/></label><br /><input type="text" class="textinput" name="user[name]" value="{name}"/></p>
      <p><label for="user[email]"><xsl:value-of select="$labels/meta/email"/></label><br /><input type="text" class="textinput" name="user[email]" value="{email}"/></p>
      <p>
        <label for="user[wysiwyg-editor]"><xsl:value-of select="$labels/login/use_wysiwyg"/></label>
        <br />
        <input type="checkbox" class="checkinput" name="user[wysiwyg-editor]" value="yes">
          <xsl:if test="wysiwyg-editor = 'yes'"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
        </input>
      </p>
      <xsl:call-template name="submit-buttons"/>
    </xsl:when>
    <xsl:otherwise>
      <p><xsl:value-of select="$labels/meta/name"/><br /><xsl:value-of select="name"/></p>
      <p><xsl:value-of select="$labels/meta/email"/><br /><xsl:value-of select="email"/></p>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="user" mode="users">
  <div name="users_{position()}" id="users_{position()}">
  <p>
    <label for="users[{position()}][user][name]"><xsl:value-of select="$labels/meta/name"/> </label>
    <input class="textinput" type="text" name="users[{position()}][user][name]" value="{name}" />
  </p>
  <p>
    <label for="users[{position()}][user][email]"><xsl:value-of select="$labels/meta/email"/> </label>
    <input class="textinput" type="text" name="users[{position()}][user][email]" value="{email}" />
  </p>
  </div>
</xsl:template>

<xsl:template name="submit-buttons">
  <xsl:param name="submit-script" select="'document.dav.submit()'"/>
  <p><label for="password"><xsl:value-of select="$labels/login/password_confirm"/></label><br /><input type="password" class="textinput" name="password" value=""/></p>
  <p>
    <input class="submitinput" type="button" value=" {$labels/buttons/save} " accesskey="s" onclick="{$submit-script}" />
    <xsl:text></xsl:text>
    <input class="submitinput" type="button" value=" {$labels/buttons/close} " accesskey="x" onclick="window.location.href = window.location.pathname;" />
  </p>
</xsl:template>

</xsl:stylesheet>