<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xml" omit-xml-declaration="yes"/>

<xsl:include href="dav_header.xsl"/>

<xsl:param name="tmp-file-update"/>
<xsl:variable name="icon"><img src="{$base}/dav/images/seta.gif" width="9" height="9" border="0" alt="{$labels/buttons/edit}" style="vertical-align: middle; text-align: right; margin-right: 5px;" /></xsl:variable>
<xsl:variable name="permissions" select="document('arg:permissions')/xpml"/>
<xsl:variable name="meta">
  <meta>
    <title><xsl:value-of select="$labels/login/page_title"/></title>
  </meta>
</xsl:variable>


<xsl:template match="/">
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body>
  <xsl:call-template name="header"/>
  <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
  <div id="col1">
  <div class="meta">
    <h3><xsl:value-of select="$labels/login/cvs_download"/></h3>
    <table cellpadding="0" cellspacing="0" border="0">
      <tr>
        <th class="first">
          <p><xsl:value-of select="$labels/login/users"/></p>
        </th>
        <td>
          <p><a href="{$script-name}?download=userinfo"><xsl:copy-of select="$icon/*"/></a></p>
        </td>
        <td>
          <p><a href="{$script-name}?download=userinfo">usr-info.txt</a></p>
        </td>
      </tr>
      <tr>
        <th class="first">
          <p><xsl:value-of select="$labels/login/groups"/></p>
        </th>
        <td>
          <p><a href="{$script-name}?download=groupinfo"><xsl:copy-of select="$icon/*"/></a></p>
        </td>
        <td>
          <p><a href="{$script-name}?download=groupinfo">grp-info.txt</a></p>
        </td>
      </tr>
    </table>
  </div>
  </div>
  <div id="col23">
    <xsl:choose>
      <xsl:when test="normalize-space($tmp-file-update) = ''">
        <form name="dav" submit-encoding="iso-8859-1" method="post" action="{$request-uri}" onsubmit="return pin_send(document.dav);" enctype="multipart/form-data">
          <h3><xsl:value-of select="$labels/login/cvs_update"/></h3>
          <br />
          <fieldset class="textinput">
            <legend><strong><xsl:value-of select="$labels/login/cvs_action"/></strong></legend>
            <label for="edituser"><input type="radio" name="upload-action" value="edit-user" id="edituser" checked="checked" />&#160;<xsl:value-of select="$labels/login/edit_users"/></label>
            <br />
            <label for="deleteuser"><input type="radio" name="upload-action" value="delete-user" id="deleteuser" />&#160;<xsl:value-of select="$labels/login/delete_users"/></label>
            <!--
            <br />
            <label for="editgroup"><input type="radio" name="upload-action" value="edit-group" id="editgroup" /> atualizar grupos</label>
            <br />
            <label for="deletegroup"><input type="radio" name="upload-action" value="delete-group" id="deletegroup" /> remover grupos</label>
            -->
          </fieldset>
          <p>
            <input type="hidden" name="MAX_FILE_SIZE" value="10000000"/>
            <label for="user-upload"><xsl:value-of select="$labels/login/cvs_datafile"/>*</label>
            <br />
            <input class="textinput" type="file" name="userupload[]" style="width: 50%"/>
          </p>
          <p>
            <input class="submitinput" type="button" value=" {$labels/buttons/save} " accesskey="s" onclick="document.dav.submit()" />
          </p>
          <p style="width: 75%; font-style: oblique;">(*) <xsl:copy-of select="$labels/login/cvs_message/*|$labels/login/cvs_message/text()"/></p>
        </form>
      </xsl:when>
      <xsl:otherwise>
        <form name="dav" submit-encoding="iso-8859-1" method="post" action="{$request-uri}" onsubmit="return pin_send(document.dav);">
          <h3><xsl:value-of select="$labels/login/cvs_update"/></h3>
          <h3><xsl:value-of select="$labels/login/cvs_update_confirm"/></h3>
          <p>
            <xsl:choose>
              <xsl:when test="$request/post/upload-action = 'edit-user'"><xsl:value-of select="$labels/login/edit_users"/></xsl:when>
              <xsl:when test="$request/post/upload-action = 'delete-user'"><xsl:value-of select="$labels/login/delete_users"/></xsl:when>
              <!--<xsl:when test="$request/post/upload-action = 'edit-group'">Atualizao dos grupos</xsl:when>
              <xsl:when test="$request/post/upload-action = 'delete-group'">Apagar grupos</xsl:when>-->
            </xsl:choose>
          </p>
          <xsl:apply-templates select="document(concat('tmp:', $user))/*" mode="cvs-info" />
          <br />
          <div style="width:50%">
            <p><label for="password"><xsl:value-of select="$labels/login/password_confirm"/></label><br /><input type="password" class="textinput" name="password" id="password" value=""/></p>
            <input type="hidden" name="upload-action" value="{$request/post/upload-action}" />
            <input type="hidden" name="update-file"   value="{$tmp-file-update}" />
            <input class="submitinput" type="button" value=" {$labels/buttons/confirm} " accesskey="s" onclick="document.dav.submit()" />
            <xsl:text></xsl:text>
            <input class="submitinput" type="button" value=" {$labels/buttons/close} " accesskey="x" onclick="window.location.href = window.location.pathname;" />
          </div>
        </form>
      </xsl:otherwise>
    </xsl:choose>
  </div>
  </body>
</html>
</xsl:template>

<xsl:template match="cvs" mode="cvs-info">
  <table cellpadding="5" cellspacing="0" border="0" class="datatable">
    <thead>
      <th>reg.</th>
      <xsl:for-each select="line[1]/*">
        <th><xsl:value-of select="name()"/></th>
      </xsl:for-each>
    </thead>
    <tbody>
      <xsl:for-each select="line">
        <tr>
          <td><xsl:value-of select="position()"/></td>
          <xsl:for-each select="*">
            <td><xsl:value-of select="."/><xsl:if test="normalize-space(.) = ''"><xsl:text> </xsl:text></xsl:if></td>
          </xsl:for-each>
        </tr>
      </xsl:for-each>
    </tbody>
  </table>
</xsl:template>

<xsl:template match="meta">
<div class="meta">
<p><xsl:value-of select="title"/></p>
</div>
</xsl:template>


</xsl:stylesheet>