<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="text" omit-xml-declaration="yes"/>

<xsl:variable name="permissions" select="document('arg:permissions')/xpml"/>

<xsl:include href="dav_header.xsl"/>

<xsl:template match="/">
<xsl:choose>
  <xsl:when test="$request/get/download = 'userinfo'"><xsl:call-template name="userinfo"/></xsl:when>
  <xsl:when test="$request/get/download = 'groupinfo'"><xsl:call-template name="groupinfo"/></xsl:when>
</xsl:choose>
</xsl:template>
  
<xsl:template name="userinfo">
<xsl:text># informaes dos usurios cadastrados no pindorama. O formato  sempre 
# definido na primeira linha de informaes. As demais definem os registros
# (cada linha  um registro): 
#
# cada campo pode utilizar aspas simples ou duplas para delimitar o contedo
# do campo. As senhas no podem ser extradas do servidor, portanto elas sero 
# sempre escritas como "xxxx"
#
#   ex.: capile, "Guilherme Capil", atendimento@capile.net, "1234", 1
#
user, name, email, password, wysiwyg-editor</xsl:text>
<xsl:for-each select="$users/user">
"<xsl:value-of select="login"/>", "<xsl:value-of select="name"/>", "<xsl:value-of select="email"/>", "xxxx", <xsl:choose><xsl:when test="wysiwyg-editor = 'yes'">1</xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>
</xsl:for-each>
</xsl:template>

<xsl:template name="groupinfo">
<xsl:text># informaes dos usurios cadastrados no pindorama. O formato  sempre 
# definido na primeira linha de informaes. As demais definem os registros
# (cada linha  um registro): 
#
# cada campo pode utilizar aspas simples ou duplas para delimitar o contedo
# do campo. As senhas no podem ser extradas do servidor, portanto elas sero 
# sempre escritas como "xxxx"
#
#   ex.: capile, "Guilherme Capil", atendimento@capile.net, "1234", 1
#
group, users</xsl:text>
<xsl:for-each select="document('arg:permissions')/xpml/resource[@name='groups']/*">
"<xsl:value-of select="name()"/>", "<xsl:value-of select="."/>"</xsl:for-each>
</xsl:template>


</xsl:stylesheet>