<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:include href="dav_header.xsl"/>
<xsl:include href="dav_meta.xsl"/>
<xsl:variable name="mime_types" select="document('arg:mime_types')/mime_types"/>

<xsl:template match="/">
<xsl:if test="count(xpml/*) = 0"><xsl:message terminate="yes"><xsl:value-of select="$labels/error/file_invalid"/></xsl:message></xsl:if>
<html>
  <head>
    <xsl:apply-templates select="xpml/meta" mode="header"/>
    <link rel="stylesheet" href="{$base}/dav/styles/calendar-blue.css" type="text/css" />
    <link rel="stylesheet" href="{$base}/dav/styles/htmlarea.css" type="text/css" />
    <script type="text/javascript" charset="iso-8859-1" src="{$base}/dav/scripts/calendar.js"><xsl:text> </xsl:text></script>
    <script type="text/javascript" charset="iso-8859-1" src="{$base}/dav/scripts/htmlarea.js"><xsl:text> </xsl:text></script>
    <script type="text/javascript" charset="iso-8859-1" src="{$base}/dav/scripts/{$language}.js"><xsl:text> </xsl:text></script>
  </head>
  <body>
    <xsl:if test="$users/user[@id = $user]/wysiwyg-editor">
      <xsl:attribute name="onload">initAllEditor(document.dav)</xsl:attribute>
    </xsl:if>
    <xsl:if test="$msg != ''">
      <p class="msg"><xsl:value-of select="$msg" disable-output-escaping="yes" /></p>
    </xsl:if>
    <xsl:call-template name="header"/>
    <form name="dav" submit-encoding="iso-8859-1" method="post" action="{$base}/edit.dav?id=db:new_{$request/auth-user}" enctype="multipart/form-data">
      <div id="hidden-data" name="hidden-data" class="invisible">
        <input type="hidden" name="dav-id" value="{$dav-id}" />
      </div>
      <div id="col23">
        <h3><xsl:value-of select="$labels/content/create"/></h3>
        <p><xsl:value-of select="$labels/content/create_alt"/></p>
        <p>
          <label for="meta[0][title]"><strong><xsl:value-of select="$labels/meta/title"/></strong></label>
          <br />
          <input type="text" name="meta[0][title]" value="{/xpml/meta/title}" class="textinput" onchange="pin_check('title', this)"  style="width:155px" />
          <input type="hidden" name="meta[format]" value="{$mime_types/*[name()=name($types/*[1])]/*[1]}" />
        </p>
        <fieldset class="textinput">
          <legend><strong><xsl:value-of select="$labels/meta/type"/></strong></legend>
          <xsl:for-each select="$types/*[name() != 'dataset']">
            <xsl:variable name="name" select="name()"/>
            <label for="{name()}">
              <input type="radio" name="meta[type]" id="{name()}" value="{name()}" onclick="this.form['meta[format]'].value='{$mime_types/*[name() = $name]/*[1]}';">
                <xsl:if test="position() = 1"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
              </input>
              <xsl:value-of select="."/>
            </label>
            <br />
          </xsl:for-each>
        </fieldset>
        <br />
        <br />
        <p>
          <input class="submitinput" type="button" value=" {$labels/buttons/save} " accesskey="s" onclick="pin_send(document.dav)" style="width: 155px;" />
          <input class="submitinput" type="button" value=" {$labels/buttons/close} " accesskey="w" onclick="window.location.href='{$base}/start';" style="width: 155px;" />
        </p>
      </div>
    </form>
  </body>
</html>
</xsl:template>

</xsl:stylesheet>