<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:param name="title"/>
<xsl:param name="select"/>
<xsl:param name="insert"/>
<xsl:variable name="meta">
  <meta>
  <title><xsl:value-of select="$title"/></title>
  </meta>
</xsl:variable>
<xsl:include href="dav_header.xsl"/>
<xsl:variable name="dir"><xsl:value-of select="normalize-space($request/get/dir)"/><xsl:if test="substring(normalize-space($request/get/dir), string-length(normalize-space($request/get/dir))) != '/'">/</xsl:if></xsl:variable>

<xsl:template match="/">
<xsl:variable name="show-header"><xsl:if test="not($select = 1 or $insert = 1)">1</xsl:if></xsl:variable>
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body>
    <xsl:call-template name="header">
      <xsl:with-param name="show-header" select="$show-header"/>
    </xsl:call-template>
    <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
    <xsl:apply-templates select="/xpml/resource[@name='sitemap']/root" mode="sitemap">
      <xsl:with-param name="ref" select="$request/get/id"/>
    </xsl:apply-templates>
    <xsl:apply-templates select="/xpml/resource[@name='uris']" mode="uris"/>
    <xsl:apply-templates select="/xpml/resource[@name='documents']" mode="documents"/>
  </body>
</html>
</xsl:template>

<xsl:template match="meta">
<div class="meta">
<p><xsl:value-of select="title"/></p>
</div>
</xsl:template>

<xsl:template mode="sitemap" match="root">
  <xsl:param name="ref"/>
  <div id="col123">
    <p>(home) <xsl:if test="boolean($select)"><a href="#" onclick="opener.pin_todo.param = ['root', 'root']; opener.pin_do_todo(); opener.focus();"><img src="{$base}/dav/images/dav_select.gif" width="11" height="11" alt="{$labels/buttons/choose}" border="0" /></a><xsl:text> </xsl:text><a href="#" onclick="opener.pin_todo.param = [' ']; opener.pin_do_todo(); opener.focus();"><xsl:value-of select="$labels/sitemap/delete"/></a></xsl:if></p>
    <xsl:variable name="display">
      <xsl:if test="count(.//*) &lt; 100">all</xsl:if>
    </xsl:variable>
    <xsl:apply-templates mode="sitemap" select="page">
      <xsl:with-param name="ref" select="$ref"/>
      <xsl:with-param name="display" select="$display"/>
    </xsl:apply-templates>
  </div>
</xsl:template>

<xsl:template mode="sitemap" match="page">
  <xsl:param name="ref"/>
  <xsl:param name="display"/>
  <div class="sitemap">
    <xsl:if test="not(following-sibling::page)">
      <xsl:attribute name="style">background: url('{$base}/dav/images/bkg-sitemap-end.gif') no-repeat;</xsl:attribute>
    </xsl:if>
    <p><xsl:apply-templates select="document(@ref)/xpml/meta" mode="sitemap"/></p>
    <xsl:choose>
      <xsl:when test="$display = 'all'">
      <xsl:apply-templates mode="sitemap" select="page">
        <xsl:with-param name="ref" select="$ref"/>
        <xsl:with-param name="display" select="$display"/>
      </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates mode="sitemap" select="page[descendant-or-self::page/@ref = $ref]">
          <xsl:with-param name="ref" select="$ref"/>
        </xsl:apply-templates>
        <xsl:if test="@ref = $ref">
          <xsl:apply-templates mode="sitemap" select="page"/>
        </xsl:if>
      </xsl:otherwise>
    </xsl:choose>
  </div>
</xsl:template>

<xsl:template mode="uris" match="resource[@name='uris']">
  <div id="col123">
  <table cellpadding="0" cellspacing="0" border="0">
  <xsl:if test="boolean($insert)">
    <tr>
    <td class="first" colspan="2">
      <form name="dir" action="#">
        <xsl:attribute name="onsubmit">return goto_dir();</xsl:attribute>
        <p><label for="new_dir"><xsl:value-of select="$labels/sitemap/select_dir"/></label></p>
        <input type="hidden" name="dir" value="{$dir}" />
        <input type="text" class="textinput" name="new_dir" id="new_dir" value="" />
        <input type="submit" class="submitinput" value="{$labels/buttons/goto}" accesskey="x" />
      </form>
    </td>
    <td colspan="2">
      <form name="dav" action="#" onsubmit="return pin_check_uri()">
        <p style="width:70%"><label for="uri"><xsl:value-of select="$labels/sitemap/select_uri"/></label></p>
        <input type="hidden" name="dir" value="{$dir}" />
        <input type="text" class="textinput" name="uri" id="uri" value="" style="width:50%" /><br />
        <input type="submit" class="submitinput" value="{$labels/buttons/choose}" accesskey="s" />
      </form>
      <script type="text/javascript" charset="iso-8859-1"><xsl:comment><xsl:text>
</xsl:text>var existing_files = new Array();function goto_dir(){if(document.dir.new_dir.value.indexOf('/')==0){window.location.href='<xsl:value-of select="$script-name"/>?dir='+document.dir.new_dir.value;}else if(document.dir.new_dir!=''){window.location.href='<xsl:value-of select="$script-name"/>?dir='+document.dir.dir.value+document.dir.new_dir.value;}else{alert('o nome da pasta precisa ser preenchido');}return false;}<xsl:text></xsl:text>
<xsl:for-each select="$uris/*[starts-with(., $dir) and not(contains(substring-after(., $dir), '/'))]">existing_files[<xsl:value-of select="position() -1"/>]="<xsl:value-of select="substring-after(., $dir)"/>";</xsl:for-each><xsl:text>
//</xsl:text></xsl:comment>
      </script>
    </td>
    </tr>
  </xsl:if>
    <tr>
      <th style="width:3%" class="first"><xsl:value-of select="$labels/meta/url"/></th>
      <th style="width:27%">&#160;</th>
      <th style="width:33%"><xsl:value-of select="$labels/meta/title"/></th>
      <th style="width:33%"><xsl:value-of select="$labels/meta/date_modified"/></th>
    </tr>
    <xsl:if test="contains($dir, '/')">
    <tr>
      <td class="first" colspan="3"><p><xsl:call-template name="r-dir"/></p></td>
    </tr>
    </xsl:if>
    <xsl:variable name="uris">
      <xsl:for-each select="uri[starts-with(., $dir)]">
        <xsl:sort select="translate(., '/_.-', '    ')" />
        <xsl:copy-of select="."/>
      </xsl:for-each>
    </xsl:variable>
    <xsl:for-each select="$uris/*[contains(substring-after(., $dir), '/')]">
      <!-- mostrar diretrio -->
      <xsl:variable name="subdir" select="concat($dir, substring-before(substring-after(., $dir), '/'))"/>
      <xsl:if test="not(preceding-sibling::uri[starts-with(., $subdir)])">
        <xsl:apply-templates select="." mode="uris" />
      </xsl:if>
    </xsl:for-each>
    <xsl:for-each select="$uris/*[not(contains(substring-after(., $dir), '/'))]">
      <xsl:choose>
        <xsl:when test="contains(@id, ':')">
          <xsl:apply-templates select="document(@id)/xpml/meta" mode="uris" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:variable name="fake"><meta><title><xsl:value-of select="$labels/meta/undef"/></title><identifier type="url"><xsl:value-of select="."/></identifier><format><xsl:value-of select="$all-formats//*[name() = substring-after(current()/text(), '.')]"/></format></meta></xsl:variable>
          <xsl:apply-templates select="$fake/meta" mode="uris" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
    <xsl:if test="not($uris/*[not(contains(substring-after(., $dir), '/'))])">
      <tr>
        <td class="first" style="color: #666666;" colspan="3">
          <xsl:value-of select="$labels/sitemap/no_documents"/>
        </td>
      </tr>
    </xsl:if>
  </table>
  </div>
</xsl:template>

<xsl:template mode="documents" match="*">
</xsl:template> 

<xsl:template mode="documents" match="resource[@name='documents']">
<xsl:variable name="all-uris" select="document('index:uris')/xpml/resource[@name='uris']"/>
<div id="col123">
  <p><strong><xsl:value-of select="$title"/></strong><br /><xsl:value-of select="$labels/sitemap/select_document"/></p>
  <table cellpadding="0" cellspacing="0" border="0">
    <tr>
      <th style="width:3%" class="first"><xsl:value-of select="$labels/meta/url"/></th>
      <th style="width:27%">&#160;</th>
      <th style="width:33%"><xsl:value-of select="$labels/meta/title"/></th>
      <th style="width:33%"><xsl:value-of select="$labels/meta/date_modified"/></th>
    </tr>
    <xsl:if test="contains($dir, '/')">
    <tr>
      <td class="first" colspan="3"><p><xsl:call-template name="r-dir"/></p></td>
    </tr>
    </xsl:if>
    <xsl:variable name="uris">
      <xsl:for-each select="$all-uris/uri[starts-with(., $dir)]">
        <xsl:sort select="translate(., '/_.-', '    ')" />
        <xsl:copy-of select="."/>
      </xsl:for-each>
    </xsl:variable>
    <xsl:for-each select="$uris/*[contains(substring-after(., $dir), '/')]">
      <!-- mostrar diretrio -->
      <xsl:variable name="subdir" select="concat($dir, substring-before(substring-after(., $dir), '/'))"/>
      <xsl:if test="not(preceding-sibling::uri[starts-with(., $subdir)])">
        <xsl:apply-templates select="." mode="uris" />
      </xsl:if>
    </xsl:for-each>
    <xsl:for-each select="$uris/*[not(contains(substring-after(., $dir), '/'))]">
      <xsl:apply-templates select="document(@id)/xpml/meta" mode="uris" />
    </xsl:for-each>
    <xsl:variable name="docs">
      <xsl:for-each select="*[not(. = $all-uris/uri/@id)]">
        <meta>
          <xsl:for-each select="document(.)/xpml/meta">
            <title><xsl:value-of select="title"/></title>
            <identifier type="id"><xsl:value-of select="identifier[@type='id']"/></identifier>
            <date type="modified"><xsl:value-of select="date[@type='modified']"/></date>
            <format><xsl:value-of select="format"/></format>
          </xsl:for-each>
        </meta>
      </xsl:for-each>
    </xsl:variable>
    <xsl:apply-templates select="$docs/meta" mode="uris"/>
    <xsl:if test="not($uris/*[not(contains(substring-after(., $dir), '/'))]) and not(*)">
      <tr>
        <td class="first" style="color: #666666;" colspan="3">
          <xsl:value-of select="$labels/sitemap/no_documents"/>
        </td>
      </tr>
    </xsl:if>
  </table>
</div>
</xsl:template>

<xsl:template name="r-dir">
<xsl:param name="r-dir" select="'/'" />
<xsl:if test="$r-dir = '/'"><a href="{$script-name}"><xsl:value-of select="$labels/sitemap/root"/>/</a><xsl:text> </xsl:text></xsl:if>
<xsl:if test="$r-dir != $dir">
  <xsl:variable name="nr-dir" select="substring-after($dir, $r-dir)"/>
  <xsl:choose>
    <xsl:when test="substring-after($nr-dir, '/') != ''">
      <a href="{$script-name}?dir={$r-dir}{substring-before($nr-dir, '/')}"><xsl:value-of select="substring-before($nr-dir, '/')"/>/</a>
      <xsl:call-template name="r-dir"><xsl:with-param name="r-dir" select="concat($r-dir, substring-before($nr-dir, '/'), '/')"/></xsl:call-template>
    </xsl:when>
    <xsl:when test="$nr-dir != ''">
      <xsl:value-of select="$nr-dir"/>
    </xsl:when>
  </xsl:choose>
</xsl:if>
</xsl:template>

<xsl:template mode="uris" match="uri">
  <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#fafffe';" class="tablerow">
    <td class="first" style="width:20px;vertical-align:middle">
      <img src="{$base}/dav/images/dir.gif" width="14" height="13" alt="diretrio" class="icon" border="0" />
    </td>
    <td style="vertical-align:middle">
        <a href="{$script-name}?dir={concat($dir, substring-before(substring-after(., $dir), '/'))}">
        <xsl:value-of select="substring-before(substring-after(., $dir), '/')"/>
        </a>
    </td>
    <td colspan="3">
      <xsl:text></xsl:text>
    </td>
  </tr>
</xsl:template>

<xsl:template mode="uris" match="meta">
  <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#fafffe';" class="tablerow">
    <td class="first" style="width:20px;">
      <img src="{$base}/dav/images/ic_{name($all-formats/*[text() = current()/format])}.gif" width="13" height="13" class="icon" alt="{.}" border="0" />
    </td>
    <td>
      <xsl:if test="not(identifier[@type='url'])"><xsl:attribute name="style">color:#666666;</xsl:attribute><xsl:value-of select="$labels/sitemap/no_url"/></xsl:if>
      <xsl:value-of select="substring-after(identifier[@type='url'], $dir)"/>
    </td>
    <td style="vertical-align:middle">
      <a><xsl:if test="identifier[@type='id']"><xsl:attribute name="href"><xsl:value-of select="concat($base, '/edit.dav?id=', identifier[@type='id'] )"/></xsl:attribute></xsl:if><xsl:value-of select="title"/></a>
    </td>
    <td style="vertical-align:middle">
      <xsl:value-of select="date[@type='modified']"/>
    </td>
    <td style="vertical-align:middle">
      <xsl:if test="not(boolean($select))">
        <xsl:if test="identifier[@type='id']"><a><xsl:attribute name="href"><xsl:value-of select="concat($base, '/edit.dav?id=', identifier[@type='id'] )"/></xsl:attribute><img src="{$base}/dav/images/dav_edit.gif" class="icon" width="11" height="11" alt="{$labels/buttons/edit}" border="0" /></a></xsl:if>
        <xsl:if test="identifier[@type='url']">
          <xsl:text></xsl:text>
          <a href="{identifier[@type='url']}"><img src="{$base}/dav/images/dav_goto.gif" class="icon" width="11" height="11" alt="{$labels/buttons/preview}" border="0" /></a>
        </xsl:if>
      </xsl:if>
      <xsl:if test="boolean($select) and identifier[@type='url']">
        <xsl:text></xsl:text>
        <a href="#" onclick="opener.pin_todo.param = '{identifier[@type='url']}'; opener.pin_do_todo(); opener.focus();"><img src="{$base}/dav/images/dav_select.gif" width="11" height="11" alt="{$labels/buttons/select}" border="0" /></a>
      </xsl:if>
    </td>
  </tr>
</xsl:template>

<xsl:template mode="sitemap" match="meta">
  <img src="{$base}/dav/images/ic_{name($formats/*[. = current()/format])}.gif" width="13" height="13" alt="{.}" border="0" />
  <xsl:text></xsl:text>
  <a><xsl:attribute name="href"><xsl:value-of select="concat($script-name, '?id=', identifier[@type='id'])"/></xsl:attribute><xsl:if test="identifier[@type='id'] = $request/get/id"><xsl:attribute name="style">color: #666666;</xsl:attribute></xsl:if><xsl:value-of select="title"/></a>
  <xsl:if test="not(boolean($select))">
    <xsl:text> </xsl:text>
    <a href="{$base}/edit.dav?id={identifier[@type='id']}"><img src="{$base}/dav/images/dav_edit.gif" width="11" height="11" alt="{$labels/buttons/edit}" border="0" /></a>
    <xsl:if test="identifier[@type='url']">
    <xsl:text></xsl:text>
    <a href="{identifier[@type='url']}"><img src="{$base}/dav/images/dav_goto.gif" width="11" height="11" alt="{$labels/buttons/preview}" border="0" /></a>
    </xsl:if>
  </xsl:if>
  <xsl:if test="boolean($select)">
    <xsl:variable name="jss">'</xsl:variable>
    <xsl:variable name="jsr"></xsl:variable>
    <xsl:text></xsl:text>
    <a href="#" onclick="opener.pin_todo.param = ['{identifier[@type='id']}', '{translate(title, $jss, $jsr)}']; opener.pin_do_todo(); opener.focus();"><img src="{$base}/dav/images/dav_select.gif" width="11" height="11" alt="{$labels/buttons/select}" border="0" /></a>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>