<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:param name="auth-user"/>
<xsl:variable name="meta">
  <meta>
  <title>Pindorama</title>
  </meta>
</xsl:variable>

<xsl:include href="dav_header.xsl"/>

<xsl:template match="/">
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body>
  <xsl:call-template name="header"/>
  <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
  <div id="col1">
    <h1><xsl:value-of select="$labels/menu/docs"/></h1>
    <xsl:call-template name="menu-document"/>
  </div>
  <div id="col2">
    <h1><xsl:value-of select="$labels/menu/index"/></h1>
    <xsl:call-template name="menu-index"/>
  </div>
  <div id="col3">
    <h1><xsl:value-of select="$labels/menu/tools"/></h1>
    <xsl:call-template name="menu-tool"/>
    <br />
    <h1><xsl:value-of select="$labels/menu/users"/></h1>
    <xsl:call-template name="menu-user"/>
  </div>
  </body>
</html>
</xsl:template>

<xsl:template match="meta">
<div class="meta">
<p><xsl:value-of select="title"/></p>
</div>
</xsl:template>

</xsl:stylesheet>