<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xml" omit-xml-declaration="yes"/>

<xsl:include href="dav_header.xsl"/>

<xsl:variable name="meta">
  <meta>
    <title><xsl:value-of select="$labels/users/users_title"/></title>
    <xsl:copy-of select="/xpml/meta/*[name() != 'title']"/>
  </meta>
</xsl:variable>

<xsl:template match="/">
<html>
  <head>
    <xsl:apply-templates select="$meta/*" mode="header"/>
  </head>
  <body>
  <xsl:call-template name="header"/>
  <xsl:if test="normalize-space($msg) != ''"><div class="msg"><p><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></div></xsl:if>
  <div id="col123">
    <h3><xsl:value-of select="$labels/users/users_title"/></h3>
    <table cellpadding="0" cellspacing="0" border="0">
      <tr>
        <th class="first"><xsl:value-of select="$labels/meta/login"/><br /><br /></th>
        <th><xsl:value-of select="$labels/meta/name"/></th>
        <th><xsl:value-of select="$labels/meta/email"/></th>
      </tr>
      <xsl:for-each select="xpml/resource[@name = 'users']/user">
        <xsl:sort select="login"/>
        <tr onMouseOver="this.bgColor='#ccddcd';" onMouseOut="this.bgColor='#fafffe';" class="tablerow">
          <td class="first">
            <xsl:value-of select="login"/>
          </td>
          <td>
            <xsl:value-of select="name"/>
          </td>
          <td>
            <xsl:value-of select="email"/>
          </td>
        </tr>
      </xsl:for-each>
    </table>
    <br />
  </div>
  <!--<div class="debug" style="display:block">
    <textarea class="textarea" style="background-color: #ffffff;"><xsl:copy-of select="document('arg:permissions')"/></textarea>
  </div>-->
  </body>
</html>
</xsl:template>

<xsl:template match="meta">
<div class="meta">
<p><xsl:value-of select="title"/></p>
</div>
</xsl:template>

</xsl:stylesheet>