<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" doctype-system="dtd/xhtml1-transitional.dtd"/>
<xsl:param name="request-uri"/>
<xsl:param name="type"/>
<xsl:param name="message" />
<xsl:variable name="labels" select="document('arg:labels')/labels"/>

<xsl:template match="/">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="pt-br" lang="pt-br">
 <head>
  <meta http-equiv="content-type" content="text/html; encoding=iso-8859-1" />
  <title><xsl:value-of select="$labels/error/title"/><xsl:text> </xsl:text><xsl:value-of select="$type"/></title>
 </head>
  <body>
     <xsl:choose>
       <xsl:when test="$type = '404'">
         <p><xsl:value-of select="$labels/error/not_found"/></p>
         <p><xsl:value-of select="$request-uri"/></p>
       </xsl:when>
       <xsl:when test="$type = '401'">
         <p><xsl:value-of select="$labels/error/unauthorized"/></p>
       </xsl:when>
       <xsl:when test="$type = '500'">
         <p><xsl:value-of select="$labels/error/server"/></p>
         <p><xsl:value-of select="$message" disable-output-escaping="yes"/></p>
       </xsl:when>
     </xsl:choose>
 </body>
</html>
</xsl:template>

</xsl:stylesheet>