<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- template de metadados
     modificado em 10.11.2003 por Guilherme Capil -->
 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="date"/>

<xsl:template match="meta">
  <xsl:param name="icon"/>
  <xsl:param name="style"/>
  <xsl:param name="script"/>
  <xsl:param name="styles"><src/></xsl:param>
  <xsl:param name="scripts"><src/></xsl:param>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" /> 
  <title><xsl:value-of select="title[not(@type = 'alternative')]"/></title>
  <xsl:if test="$style != ''">
    <link rel="stylesheet" href="{$style}" type="text/css" />
  </xsl:if>
  <xsl:for-each select="$styles/*[normalize-space(.) != '']">
    <link rel="stylesheet" href="{.}" type="text/css" />
  </xsl:for-each>
  <xsl:if test="$script != ''">
    <script type="text/javascript" src="{$script}" charset="iso-8859-1" />
  </xsl:if>
  <xsl:for-each select="$scripts/*[normalize-space(.) != '']">
    <script type="text/javascript" src="{.}" charset="iso-8859-1" />
  </xsl:for-each>
  <xsl:if test="$icon != ''">
    <link rel="shortcut icon" href="{$icon}" />
  </xsl:if>
  <xsl:choose>
    <xsl:when test="normalize-space($date) != ''">
      <meta name="date" scheme="W3CDTF" content="{$date}" /> 
    </xsl:when>
    <xsl:when test="date[@type = 'issued']">
      <meta name="date" scheme="W3CDTF" content="{date[@type = 'issued']}" /> 
    </xsl:when>
    <xsl:otherwise>
      <meta name="date" scheme="W3CDTF" content="{date[@type = 'modified']}" /> 
    </xsl:otherwise>
  </xsl:choose>
  <xsl:apply-templates mode="meta" />
</xsl:template>

<xsl:template match="*" mode="meta">
  <meta name="{name()}">
    <xsl:attribute name="content">
      <xsl:choose>
        <xsl:when test="normalize-space(text()) != ''"><xsl:value-of select="normalize-space(text())"/></xsl:when>
        <xsl:otherwise>
          <xsl:apply-templates select="//*" mode="list"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
  </meta>
</xsl:template>

<xsl:template mode="list">
  <xsl:param name="sep" select="', '"/>
  <xsl:if test="position() != 1"><xsl:value-of select="$sep"/></xsl:if>
  <xsl:value-of select="normalize-space(text())"/>
</xsl:template>

<xsl:template match="format" mode="meta">
  <meta name="{name()}" content="text/html" />
</xsl:template>

<xsl:template match="title[not(@type='alternative')]|relation|date|identifier[@type='id']" mode="meta" priority="1"></xsl:template>

<xsl:template match="text()" mode="meta" />

</xsl:stylesheet>