<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xml" omit-xml-declaration="yes"/>

<xsl:include href="dav/dav_header.xsl"/>

<xsl:template match="/">
  <xsl:choose>
    <xsl:when test="$request/get/resource"><xsl:copy-of select="/xpml/resource[(count(preceding-sibling::resource) +1) = $request/get/resource]"/></xsl:when>
    <xsl:when test="/xpml/meta/format != 'application/x-httpd-php' and /xpml/meta/format != 'text/html'"><xsl:apply-templates mode="preview" /></xsl:when>
    <xsl:when test="/xpml/meta/identifier[@type='url']"><xsl:value-of select="/xpml/meta/identifier[@type='url']"/></xsl:when>
    <xsl:when test="$all-formats/*[. = /xpml/meta/format]">.tmp<xsl:value-of select="name($all-formats/*[. = /xpml/meta/format])"/></xsl:when>
    <xsl:otherwise>/.tmp-<xsl:value-of select="$request/auth-user"/></xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template mode="preview" match="xpml">
<html>
  <head>
    <xsl:apply-templates select="meta" mode="header"/>
  </head>
  <body>
    <xsl:call-template name="header"/>
    <xsl:if test="$msg != ''"><p class="msg"><xsl:value-of select="$msg" disable-output-escaping="yes" /></p></xsl:if>
    <div id="col123">
      <xsl:apply-templates select="resource"/>
    </div>
  </body>
</html>
</xsl:template>

<xsl:template match="resource[@type = 'content']">
  <div class="preview" style="width: 100%; overflow: scroll;">
    <pre>
    <xsl:value-of select="content" disable-output-escaping="no"/>
    </pre>
  </div>
</xsl:template>

<xsl:template match="resource[@type = 'binary']">
<xsl:param name="position" select="count(preceding-sibling::resource) + 1"/>
  <xsl:choose>
    <xsl:when test="starts-with(resource-description/format, 'image/')">
      <xsl:variable name="preview-url" select="concat('/preview.dav?id=', $request/get/id, '&amp;resource=', $position)"/>
      <div class="preview">
        <img src="{$preview-url}&amp;name={resource-description/name}" alt="comments" border="0" />
      </div>
    </xsl:when>
  </xsl:choose>
</xsl:template>

</xsl:stylesheet>