<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">

<xsl:param name="data-dir"/>

<xsl:template match="resource[@type='data-form']" priority="1">
  <xsl:variable name="e" select="'x[ref]'"/>
  <xsl:variable name="id" select="'new_record'"/>
  <xsl:variable name="action"><xsl:choose><xsl:when test="ref != ''"><xsl:value-of select="ref"/></xsl:when><xsl:otherwise><xsl:value-of select="$xpml/meta/identifier[@type='url']"/></xsl:otherwise></xsl:choose></xsl:variable>
  <!--<h3><xsl:value-of select="title"/></h3>-->
  <xsl:variable name="component" select="include/include"/>
  <xsl:if test="$component != ''">
    <xsl:value-of select="document(concat('include:', $component))/comment()" disable-output-escaping="yes"/>
  </xsl:if>
  <xsl:if test="$xpml/meta/format = 'application/x-httpd-php'">
    <xsl:processing-instruction name="php">
      <xsl:text>global $df; if (is_array($_POST["x"])) {  $df = array(); $df["post"] = $_POST; $df["id"] = "</xsl:text><xsl:value-of select='substring-after(dataset/@ref, "#")'/><xsl:text>"; $df["method"] = "</xsl:text><xsl:value-of select='method'/><xsl:text>"; $df["data-dir"] = "</xsl:text><xsl:value-of select='$data-dir'/><xsl:text>";</xsl:text>
      <xsl:for-each select="dataset//field">$df["elements"][] = array("name"=>"<xsl:value-of select='name'/>", "label"=>"<xsl:value-of select='label'/>", "required"=>"<xsl:value-of select='@required'/>", "type"=>"<xsl:value-of select='type'/>");</xsl:for-each>
      <xsl:for-each select="*[name() != 'dataset' and name() != 'notification-email']">$df["<xsl:value-of select='name()'/>"]=<xsl:text disable-output-escaping="yes">&lt;&lt;&lt;EOF
</xsl:text><xsl:apply-templates select='.' mode="safe-php"/><xsl:text>
EOF;
</xsl:text></xsl:for-each>
      <xsl:for-each select="notification-email">$df["to"][]="<xsl:apply-templates select='.' mode='safe-php'/>";</xsl:for-each>
      <xsl:text>};</xsl:text>
    </xsl:processing-instruction>
    <xsl:value-of select="document('include:data-form.php')/comment()" disable-output-escaping="yes"/>
    <xsl:processing-instruction name="php">
     <xsl:text disable-output-escaping="yes">if (is_array($_POST["x"]) &amp;&amp; send_data()) { echo $df['success-message'];$df["success"] = TRUE; } else { if (is_array($_POST["x"])) { echo $df['error-message']; serialize_jsform ($_POST); } else { </xsl:text>
    </xsl:processing-instruction>
  </xsl:if>
  <div><xsl:value-of select="content" disable-output-escaping="yes"/></div>
  <xsl:if test="$xpml/meta/format = 'application/x-httpd-php'">
    <xsl:processing-instruction name="php">};</xsl:processing-instruction>
  </xsl:if>
  <script type="text/javascript" charset="iso-8859-1"><xsl:text disable-output-escaping="yes">&lt;!-</xsl:text><xsl:text>-
</xsl:text><xsl:value-of select="document('include:site-components.js')/comment()" disable-output-escaping="yes"/><xsl:text>
//-</xsl:text><xsl:text disable-output-escaping="yes">-&gt;</xsl:text></script>
  <form name="usr" id="usr" action="{$action}" onsubmit="return send(this.form);" method="post" enctype="multipart/form-data">
    <input type="hidden" name="{$e}[@id]" value="{substring-after(dataset/@ref, '#')}#{$id}"/>
    <br />
    <p style="color: #996666;">Ateno: os campos marcados com * so obrigatrios.</p>
    <xsl:apply-templates select="dataset/field|dataset/fieldset|dataset/inline|dataset/page" mode="dataset-editing">
      <xsl:with-param name="e" select="$e"/>
    </xsl:apply-templates>
    <br />
    <xsl:if test="dataset/page">
    <div class="btn" style="display:none;">
      <input type="button" value="Enviar" onclick="return send(this.form);" class="submitinput" />
    </div>
    </xsl:if>
    <xsl:if test="not(dataset/page)">
    <div class="btn">
      <input type="button" value="Enviar" onclick="return send(this.form);" class="submitinput" />
    </div>
    </xsl:if>
  </form>
  <xsl:if test="$xpml/meta/format = 'application/x-httpd-php'">
    <xsl:processing-instruction name="php"><xsl:text disable-output-escaping="yes">}; if ($df["success"]) { echo "&lt;p&gt;&lt;a href=\"{$df["http-referer"]}\">Retornar ao formulrio&lt;/a>&lt;/p>"; }</xsl:text></xsl:processing-instruction>
  </xsl:if>
</xsl:template>

<xsl:template match="resource[@type='data-preview'][include != '']" priority="1">
  <xsl:variable name="e" select="'x[ref]'"/>
  <xsl:variable name="id" select="'new_record'"/>
  <xsl:variable name="action"><xsl:choose><xsl:when test="ref != ''"><xsl:value-of select="ref"/></xsl:when><xsl:otherwise><xsl:value-of select="$xpml/meta/identifier[@type='url']"/></xsl:otherwise></xsl:choose></xsl:variable>
  <xsl:variable name="component" select="document(include)//include"/>
  <!--<h3><xsl:value-of select="title"/></h3>-->
  <xsl:if test="$xpml/meta/format = 'application/x-httpd-php'">
    <xsl:processing-instruction name="php">
      <xsl:text>global $df; $df = array(); $df["id"] = "</xsl:text><xsl:value-of select='substring-after(dataset/@ref, "#")'/><xsl:text>"; $df["method"] = "</xsl:text><xsl:value-of select='method'/><xsl:text>"; $df["data-dir"] = "</xsl:text><xsl:value-of select='$data-dir'/><xsl:text>";</xsl:text>
      <xsl:for-each select="dataset//field">$df["elements"]["<xsl:value-of select='name'/>"] = array("label"=>"<xsl:value-of select='label'/>", "required"=>"<xsl:value-of select='@required'/>", "type"=>"<xsl:value-of select='type'/>");</xsl:for-each>
      <xsl:for-each select="dataset//fieldset">$df["fieldsets"][] = array("legend"=>"<xsl:value-of select='legend'/>", "elements"=>array(<xsl:for-each select="field|inline"><xsl:if test="position()&gt;1">,</xsl:if><xsl:choose><xsl:when test="name()='inline'">array(<xsl:for-each select="field"><xsl:if test="position()&gt;1">,</xsl:if>"<xsl:value-of select='name'/>"</xsl:for-each>)</xsl:when><xsl:otherwise>"<xsl:value-of select='name'/>"</xsl:otherwise></xsl:choose></xsl:for-each>));</xsl:for-each>
      <xsl:for-each select="*[name() != 'dataset' and name() != 'notification-email']">$df["<xsl:value-of select='name()'/>"]=<xsl:text disable-output-escaping="yes">&lt;&lt;&lt;EOF
</xsl:text><xsl:apply-templates select='.' mode="safe-php"/><xsl:text>
EOF;
</xsl:text></xsl:for-each>
      <xsl:for-each select="notification-email">$df["to"][]="<xsl:apply-templates select='.' mode='safe-php'/>";</xsl:for-each>
    </xsl:processing-instruction>
    <xsl:value-of select="document(concat('include:', $component))/comment()" disable-output-escaping="yes"/>
  </xsl:if>
</xsl:template>

<xsl:template match="page" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos" select="1"/>
<xsl:variable name="arr" select="concat('arr', position())"/>
<div id="pg{position()}" name="pg{position()}" class="pg">
  <xsl:choose>
    <xsl:when test="position() = 1">
      <xsl:attribute name="style">display:block</xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
      <xsl:attribute name="style">display:none</xsl:attribute>
    </xsl:otherwise>
  </xsl:choose>
  <script type="text/javascript" charset="iso-8859-1"><xsl:text disable-output-escaping="yes">&lt;!-</xsl:text><xsl:text>-
var </xsl:text><xsl:value-of select="$arr"/><xsl:text> = [];</xsl:text>
    <xsl:for-each select=".//field"><xsl:value-of select="$arr"/>[<xsl:value-of select="$arr"/>.length]='<xsl:value-of select="$e"/>[<xsl:value-of select="name"/>]';</xsl:for-each><xsl:text>
//-</xsl:text><xsl:text disable-output-escaping="yes">-&gt;</xsl:text></script>
  <h3>Passo <xsl:value-of select="position()"/> de <xsl:value-of select="count(../page)"/>.</h3>
  <xsl:apply-templates select="field|fieldset|inline" mode="dataset-editing">
    <xsl:with-param name="ref" select="$ref"/>
    <xsl:with-param name="e" select="$e"/>
    <xsl:with-param name="pos" select="$pos"/>
  </xsl:apply-templates>
  <div class="pgbtn">
  <xsl:choose>
    <xsl:when test="position() &gt;1">
      <input type="button" value=" anterior" onclick="return send_page({$arr}, this.form, 'pg{position()}', 'pg{position()-1}', false);" class="submitinput" />
    </xsl:when>
    <xsl:otherwise>
      <input type="button" style="color:#666666" id="readonly" readonly="readonly" value=" anterior" onclick="return false;" class="submitinput" />
    </xsl:otherwise>
  </xsl:choose>
  <xsl:choose>
    <xsl:when test="following-sibling::page">
      <input type="button" value="prxima " onclick="return send_page({$arr}, this.form, 'pg{position()}', 'pg{position()+1}', false);" class="submitinput" />
    </xsl:when>
    <xsl:otherwise>
      <input type="button" value="Enviar" onclick="return send(this.form);" class="submitinput" />
    </xsl:otherwise>
  </xsl:choose>
  </div>
</div>
</xsl:template>

<xsl:template match="fieldset" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos" select="1"/>
  <fieldset>
    <legend><xsl:value-of select="legend"/></legend>
    <table cellpadding="0" cellspacing="0" border="0" width="75%">
    <xsl:apply-templates select="field|fieldset|inline" mode="dataset-editing">
      <xsl:with-param name="ref" select="$ref"/>
      <xsl:with-param name="e" select="$e"/>
      <xsl:with-param name="pos" select="$pos"/>
    </xsl:apply-templates>
    <tr>
      <td width="75px"><img src="/_images/nada.gif" border="0" height="1" width="75" /></td>
      <td width="150px"><img src="/_images/nada.gif" border="0" height="1" width="150" /></td>
      <td width="75px"><img src="/_images/nada.gif" border="0" height="1" width="75" /></td>
      <td width="150px"><img src="/_images/nada.gif" border="0" height="1" width="150" /></td>
    </tr>
    </table>
  </fieldset>
</xsl:template>

<xsl:template match="inline" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos" select="1"/>
  <tr>
  <xsl:for-each select="fieldset|field|inline">
      <xsl:apply-templates select="." mode="dataset-editing">
        <xsl:with-param name="ref" select="$ref"/>
        <xsl:with-param name="e" select="$e"/>
        <xsl:with-param name="pos" select="$pos"/>
        <xsl:with-param name="row" select="'span'"/>
        <xsl:with-param name="cols" select="1"/>
      </xsl:apply-templates>
  </xsl:for-each>
  </tr>
</xsl:template>

<xsl:template match="field" mode="dataset-editing"/>

<xsl:template match="field[type='tinytext']|field[type='smalltext']|field[contains(type, 'int')]|field[type='email']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
  <xsl:element name="{$row}">
  <td width="75px">
  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  </p>
  </td>
  <td>
    <xsl:if test="$cols &gt; 1 "><xsl:attribute name="colspan"><xsl:value-of select="$cols"/></xsl:attribute></xsl:if>
  <p>
    <input required="{@required}" title="{description}" label="{label}" type="text" name="{$e}[{name}]" id="{$e}[{name}]" value="{$ref/*[name() = current()/name]}" class="textinput" onchange="check('{type}', this)" />
  </p>
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[type='text' or type='phone']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
  <xsl:element name="{$row}">
  <td width="75px">
  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  </p>
  </td>
  <td colspan="{$cols}">
  <p>
    <input required="{@required}" title="{description}" label="{label}" type="text" name="{$e}[{name}]" id="{$e}[{name}]" value="{$ref/*[name() = current()/name]}" class="textinput" onchange="check('{type}', this)" />
  </p>
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[type='boolean']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
  <xsl:element name="{$row}">
  <td width="75px">
    <xsl:text> </xsl:text>
  </td>
  <td colspan="{$cols}">
  <p>
    <input required="{@required}" title="{description}" label="{label}" type="checkbox" name="{$e}[{name}]" id="{$e}[{name}]" value="{value}" class="checkinput" onchange="check('{type}', this)">
      <xsl:if test="$ref/*[name() = current()/name] = value"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
    </input>
    <xsl:text> </xsl:text>
    <xsl:if test="not($no-label=1)">
      <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  </p>
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[type='set' and type/@display='extended']" mode="dataset-editing" priority="1">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
<xsl:variable name="value" select="$ref/*[name() = current()/name]"/>
  <xsl:element name="{$row}">
  <td colspan="{$cols + 1}" width="75px">
  <fieldset>
    <xsl:if test="not($no-label=1)">
      <legend><xsl:value-of select="label"/><xsl:if test="@required = 'yes'">*</xsl:if></legend>
    </xsl:if>
    <xsl:text> </xsl:text>
    <div class="padl100">
    <xsl:for-each select="select/ref[@id != '']">
      <label for="{$e}[{../../name}][{position()}]">
      <input required="{../../@required}" title="{../../description}" label="{../../label}" type="radio" name="{$e}[{../../name}]" id="{$e}[{../../name}][{position()}]" value="{@id}" class="checkinput" onchange="check('{../../type}', this)">
        <xsl:if test="$value = @id"><xsl:attribute name="checked">checked</xsl:attribute></xsl:if>
      </input>
      <xsl:text>&#160;</xsl:text>
      <xsl:value-of select="."/>
      </label>
      <xsl:text>&#160;&#160;&#160;</xsl:text>
      <br />
    </xsl:for-each>
    </div>
  </fieldset>
  </td>
  </xsl:element>
</xsl:template>

<!--<xsl:template match="field[type='set']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
  <xsl:element name="{$row}">
  <td width="60px">
  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  </p>
  </td>
  <td colspan="{$cols}">
  <p>
    <select required="{@required}" title="{description}" label="{label}" type="text" name="{$e}[{name}]" id="{$e}[{name}]" class="textinput" onchange="check('{type}', this)">
      <option value="">&#151;</option>
      <xsl:for-each select="select/ref[@id != '']">
        <option value="{@id}"><xsl:if test="@id = $value"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if><xsl:value-of select="."/></option>
      </xsl:for-each>
    </select>
  </p>
  </td>
  </xsl:element>
</xsl:template>-->

<xsl:template match="field[type='mediumtext']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos" select="1"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
  <xsl:element name="{$row}">
  <td width="60px" style="vertical-align:top">
  <p>
    <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
    <xsl:if test="@required = 'yes'">*</xsl:if>
  </p>
  </td>
  <td colspan="{$cols}">
  <textarea required="{@required}" rows="8" title="{description}" label="{label}" name="{$e}[{name}]" id="{$e}[{name}]" class="textinput" onchange="check('{type}', this)">
    <xsl:value-of select="$ref/*[name() = current()/name]"/>
  </textarea>
  <br />
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[type='longtext']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos" select="1"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
  <xsl:element name="{$row}">
  <td colspan="">
  <p>
    <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
    <xsl:if test="@required = 'yes'">*</xsl:if>
  </p>
  </td>
  </xsl:element>
  <xsl:element name="{$row}">
  <td colspan="{$cols + 1}">
  <textarea required="{@required}" rows="16" title="{description}" label="{label}" name="{$e}[{name}]" id="{$e}[{name}]" class="textinput" onchange="check('{type}', this)">
    <xsl:value-of select="$ref/*[name() = current()/name]"/>
  </textarea>
  <br />
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[type='date']|field[type='date-time']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
<xsl:variable name="date-comp"><xsl:if test="type='date-time'">T<xsl:value-of select="substring-after($date, 'T')"/></xsl:if></xsl:variable>
  <xsl:element name="{$row}">
  <td width="60px">
  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  </p>
  </td>
  <td colspan="{$cols}">
  <p>
    <input required="{@required}" title="{description}" label="{label}" type="text" name="{$e}[{name}]" id="{$e}[{name}]" value="{$ref/*[name() = current()/name]}" class="textinput" style="width: 75%;" onchange="check('{type}', this)" />
    <input type="button" value="..." class="submitinput" onclick="return showCalendar(this.previousSibling, 'y-mm-dd{$date-comp}');" style="width: 22%;" />
  </p>
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[(type='ref' or type='ref-value' or type='ref-copy') and @ref != '']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:variable name="index" select="@ref"/>
<xsl:variable name="value">
  <xsl:choose>
    <xsl:when test="type='ref'"><xsl:value-of select="$ref/*[name() = current()/name]"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="$ref/*[name() = current()/name]/@ref"/></xsl:otherwise>
  </xsl:choose>
</xsl:variable>
<xsl:variable name="el"><xsl:value-of select="concat($e, '[', name, ']')"/><xsl:if test="type='ref'">[@xpml-id]</xsl:if><xsl:if test="type='ref-value'">[@xpml-value]</xsl:if><xsl:if test="type='ref-copy'">[@xpml-copy]</xsl:if></xsl:variable>
<xsl:variable name="subel" select="element" />

<xsl:variable name="required" select="@required"/>
<xsl:variable name="label" select="label"/>
<xsl:variable name="description" select="description"/>
<xsl:variable name="type" select="type"/>

  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$el}"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
    <xsl:for-each select="document(@ref)/xpml">
      <xsl:choose>
        <xsl:when test="count(resource/*[@id != '']) &gt; 10">
          <xsl:variable name="output-value"><xsl:choose><xsl:when test="$subel != ''"><xsl:value-of select="$value"/></xsl:when><xsl:otherwise><xsl:value-of select="resource/*[@id = substring-after($value, '#')]"/></xsl:otherwise></xsl:choose></xsl:variable>
          <input required="{$required}" title="{$description}" label="{$label}" type="hidden" name="{$el}" id="{$el}" value="{$value}" />
          <input name="tmp{$el}" id="tmp{$el}" value="{$output-value}" class="textinput" style="width: 75%;" onchange="check('{type}', this)" />
          <input type="button" value="..." class="submitinput" onclick="todo.action = 'update_list(\'{$el}\', \'{$subel}\');';list_index(this, '{$index}', '')" style="width: 22%;" />
        </xsl:when>
        <xsl:otherwise>
          <select required="{$required}" title="{$description}" label="{$label}" name="{$el}" id="{$el}" class="textinput" onchange="check('{$type}', this)">
            <option value="">&#151;</option>
            <xsl:for-each select="resource/*[@id != '']">
              <xsl:sort />
              <xsl:choose>
                <xsl:when test="$subel != ''">
                  <option value="{$index}#{@id}.{$subel}"><xsl:if test="concat($index, '#', @id, '.', $subel) = $value or (*[name() = $subel] = $value)"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if><xsl:value-of select="*[normalize-space(.) != ''][1]"/><xsl:if test="not(*[normalize-space(.) != ''][1])"><xsl:value-of select="."/></xsl:if></option>
                </xsl:when>
                <xsl:otherwise>
                  <option value="{$index}#{@id}"><xsl:if test="concat($index, '#', @id) = $value"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if><xsl:value-of select="*[normalize-space(.) != ''][1]"/><xsl:if test="not(*[normalize-space(.) != ''][1])"><xsl:value-of select="."/></xsl:if></option>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:for-each>
          </select>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
  </p>
</xsl:template>

<xsl:template match="field[type='multiple-ref' and @ref != '']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:variable name="index" select="@ref"/>
<xsl:variable name="value">
  <xsl:choose>
    <xsl:when test="type='multiple-ref'"><xsl:copy-of select="$ref/*[name() = current()/name]"/></xsl:when>
    <xsl:otherwise><xsl:for-each select="$ref/*[name() = current()/name]/@ref"><ref><xsl:value-of select="."/></ref></xsl:for-each></xsl:otherwise>
  </xsl:choose>
</xsl:variable>
<xsl:variable name="el"><xsl:value-of select="concat($e, '[][', name, ']')"/><xsl:if test="type='ref'">[@xpml-id]</xsl:if><xsl:if test="type='ref-value'">[@xpml-value]</xsl:if><xsl:if test="type='ref-copy'">[@xpml-copy]</xsl:if></xsl:variable>
  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$el}"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
    <select required="{@required}" title="{description}" label="{label}" multiple="multiple" name="{$el}" id="{$el}" class="textinput" onchange="check('{type}', this)">
      <xsl:for-each select="document(@ref)/xpml/resource/*[@id != '']">
        <option value="{$index}#{@id}"><xsl:if test="concat($index, '#', @id) = $value/*"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if><xsl:value-of select="*[normalize-space(.) != ''][1]"/><xsl:if test="not(*[normalize-space(.) != ''][1])"><xsl:value-of select="."/></xsl:if></option>
      </xsl:for-each>
    </select>
  </p>
</xsl:template>

<xsl:template match="field[(type='ref' or type='ref-value' or type='ref-copy') and @ref != '' and @write = 'yes']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos"/>
<xsl:param name="no-label"/>
<xsl:variable name="index" select="@ref"/>
<xsl:variable name="value">
  <xsl:choose>
    <xsl:when test="type='ref'"><xsl:value-of select="$ref/*[name() = current()/name]"/></xsl:when>
    <xsl:otherwise><xsl:value-of select="$ref/*[name() = current()/name]/@ref"/></xsl:otherwise>
  </xsl:choose>
</xsl:variable>
<xsl:variable name="new-value"><xsl:if test="$value = ''"><xsl:value-of select="concat($index, '#latest')"/></xsl:if></xsl:variable>
<xsl:variable name="ref-table">
  <xsl:choose>
    <xsl:when test="$value != ''">
      <xsl:for-each select="document($value)/*">
        <ref id="{$value}">
          <xsl:copy-of select="@*[name() != 'id']|*|text()"/>
        </ref>
      </xsl:for-each>
    </xsl:when>
    <xsl:otherwise>
      <xsl:for-each select="document($new-value)/*">
        <ref id="{$new-value}">
        </ref>
      </xsl:for-each>
    </xsl:otherwise>
  </xsl:choose>
</xsl:variable>
<xsl:variable name="el"><xsl:value-of select="concat($e, '[', name, ']')"/><xsl:if test="type='ref'">[@xpml-id]</xsl:if><xsl:if test="type='ref-value'">[@xpml-value]</xsl:if><xsl:if test="type='ref-copy'">[@xpml-copy]</xsl:if></xsl:variable>
    <xsl:if test="not($no-label=1)">
      <label for="{$el}"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  <div style="border: 1px solid #cccccc;padding: 5px;"><xsl:value-of select="$value"/>
    <input type="hidden" name="{$el}" id="{$el}" value="{$value}{$new-value}"/>
    <xsl:apply-templates select="$ref-table/*" mode="dataset-editing">
      <xsl:with-param name="hide-id" select="'1'"/>
      <xsl:with-param name="datasets"><xsl:copy-of select="document('index:datasets')/xpml/resource[@ref = $index]/*"/></xsl:with-param>
      <xsl:with-param name="e" select="concat('x[', position() + 0 + 100, '][ref]')"/>
    </xsl:apply-templates>
  </div>
  <br />
</xsl:template>

<xsl:template match="field[type='set']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="no-label"/>
<xsl:param name="row" select="'tr'"/>
<xsl:param name="cols" select="3"/>
<xsl:variable name="value" select="$ref/*[name() = current()/name]"/>
  <xsl:element name="{$row}">
  <td width="60px">
  <p>
    <xsl:if test="not($no-label=1)">
      <label for="{$e}[{name}]"><xsl:value-of select="label"/></label>
      <xsl:if test="@required = 'yes'">*</xsl:if>
      <br />
    </xsl:if>
  </p>
  </td>
  <td colspan="{$cols}">
  <p>
    <select required="{@required}" title="{description}" label="{label}" type="text" name="{$e}[{name}]" id="{$e}[{name}]" class="textinput" onchange="check('{type}', this)">
      <option value="">&#151;</option>
      <xsl:for-each select="select/ref[@id != '']">
        <option value="{@id}"><xsl:if test="@id = $value"><xsl:attribute name="selected">selected</xsl:attribute></xsl:if><xsl:value-of select="."/></option>
      </xsl:for-each>
    </select>
  </p>
  </td>
  </xsl:element>
</xsl:template>

<xsl:template match="field[type='binfile']" mode="dataset-editing">
<xsl:param name="ref"><empty/></xsl:param>
<xsl:param name="e" select="'dataset[ref]'"/>
<xsl:param name="pos" select="1"/>
<xsl:param name="no-label"/>
    <xsl:variable name="preview-url" select="concat($base, '/preview.dav?src=', $ref/*[name() = current()/name]/@ref-src)"/>
    <p><xsl:value-of select="label"/></p>
    <input type="hidden" name="{$e}[{name}][@xpml-file]" value="{$ref/*[name() = current()/name]/@ref-src}"/>
    <input type="hidden" name="{$e}[{name}][]" value="0"/>
    <div id="tmp{$pos}" style="display:none;">
      <input type="hidden" name="MAX_FILE_SIZE" value="10000000"/>
      <input type="hidden" name="{$e}[{name}][@xpml-import-upload-file]" value="resource-{$pos}"/>
      <input class="textinput" type="file" name="resource-{$pos}" />
    </div>
    <div>
    <table cellpadding="0" cellspacing="0" border="0">
      <tr>
        <td style="padding: 1px 5px 0 5px; background: #eeeeee; color: #666666; border: 1px solid #666666" class="first" width="69%">
          <xsl:if test="$ref/*[name() = current()/name]/@ref-src">
            <strong><a href="{$preview-url}&amp;name={$ref/*[name() = current()/name]/name}" target="_files"><xsl:value-of select="$ref/*[name() = current()/name]/name"/></a></strong>
            <br /><strong>Formato</strong><xsl:text>&#160;</xsl:text><xsl:value-of select="$ref/*[name() = current()/name]/format"/>
            <br /><strong>Tamanho</strong><xsl:text>&#160;</xsl:text><xsl:apply-templates mode="filesize" select="$ref/*[name() = current()/name]/size"/>
            <xsl:if test="substring-before($ref/*[name() = current()/name]/date, 'T') != ''">
              <br /><strong>Enviado em</strong><xsl:text>&#160;</xsl:text><xsl:value-of select="substring-before($ref/*[name() = current()/name]/date, 'T')"/>
            </xsl:if>
          </xsl:if>
          <xsl:text>&#160;</xsl:text>
        </td>
        <td>
          <input type="button" class="submitinput" onclick="xChangeVisibility('tmp{$pos}')" value=" ... " style="width:100%"/>
        </td>
      </tr>
    </table>
    </div>
    <br />
</xsl:template>

</xsl:stylesheet>