<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="identifier[@type='id']" mode="header">
  <xsl:variable name="id" select="."/>
  <xsl:comment>noindex</xsl:comment>
  <div id="header">
    <div id="topnav">
      <p>
        <xsl:choose>
          <xsl:when test="$sitemap//root/page[descendant-or-self::page/@ref = $id]">
            <xsl:for-each select="$sitemap//root/page[descendant-or-self::page/@ref = $id]">
              <a href="{$uris/uri[@id = current()/@ref]}"><img src="/_images/logotipo.gif" alt="Pindorama" border="0" /></a>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <xsl:for-each select="$sitemap//root/page[1]">
              <a href="{$uris/uri[@id = current()/@ref]}"><img src="/_images/logotipo.gif" alt="Pindorama" border="0" /></a>
            </xsl:for-each>
          </xsl:otherwise>
        </xsl:choose>
      </p>
      <p>
        <xsl:for-each select="$sitemap//root/page[not(descendant-or-self::page/@ref = $id)]">
          <xsl:if test="position() != 1"> | </xsl:if>
          <xsl:for-each select="document(@ref)/xpml/meta">
            <a href="{$uris/uri[@id = current()/identifier[@type='id']]}">
              <xsl:choose>
                <xsl:when test="title[@type='alternative']"><xsl:value-of select="title[@type='alternative']"/></xsl:when>
                <xsl:otherwise><xsl:value-of select="title[1]"/></xsl:otherwise>
              </xsl:choose>
            </a>
          </xsl:for-each>
        </xsl:for-each>
      </p>
      <xsl:apply-templates select="$xpml/resource[position = 'header']"/>
    </div>
  </div>
  <xsl:comment>index</xsl:comment>
</xsl:template>

</xsl:stylesheet>