<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="page" mode="horizontal-nav">
  <xsl:variable name="class">
    <xsl:if test="descendant-or-self::page/@ref = $id">headersel</xsl:if>
  </xsl:variable>
  <xsl:variable name="title" select="document(@ref)/xpml/meta/title"/>
  <xsl:if test="position() != 1"> | </xsl:if>
  <xsl:apply-templates select="document(@ref)/xpml/meta" mode="link">
    <xsl:with-param name="class" select="$class"/>
  </xsl:apply-templates>
</xsl:template>

<xsl:template mode="navcontext" match="xpml">
  <xsl:variable name="title" select="meta/title"/>
  <div id="navc">
    <xsl:choose>
      <xsl:when test="$sitemap//root/page[descendant-or-self::page/@ref = $id]">
        <xsl:for-each select="$sitemap/root/page[descendant-or-self::page/@ref = $id][page]">
          <!--<p><xsl:apply-templates mode="link" select="document(@ref)/xpml/meta"/></p>-->
          <xsl:if test="descendant-or-self::page/@ref = $id and page">
            <ul>
            <xsl:apply-templates select="page" mode="navcontext"/>
            </ul>
          </xsl:if>
        </xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <xsl:for-each select="$sitemap/root/page[1][page]">
            <ul>
            <xsl:apply-templates select="page" mode="navcontext"/>
            </ul>
        </xsl:for-each>
      </xsl:otherwise>
    </xsl:choose>
  </div>
</xsl:template>

<xsl:template match="page" mode="navcontext">
  <li><xsl:apply-templates mode="link" select="document(@ref)/xpml/meta"/>
  <xsl:if test="descendant-or-self::page/@ref = $id">
    <ul>
    <xsl:apply-templates select="page" mode="navcontext"/>
    </ul>
  </xsl:if></li>
</xsl:template>

<xsl:template match="page" mode="linkv">
  <p>
    <xsl:choose>
      <xsl:when test="@ref=$id"><xsl:value-of select="document(@ref)/xpml/meta/title"/></xsl:when>
      <xsl:otherwise><xsl:apply-templates mode="link" select="document(@ref)/xpml/meta"/></xsl:otherwise>
    </xsl:choose>
  </p>
</xsl:template>

<xsl:template match="meta" mode="link">
  <xsl:param name="class"/>
  <xsl:choose>
    <xsl:when test="not(identifier[@type='id'] = $id)">
  <a>
    <xsl:if test="$class != ''">
      <xsl:attribute name="class"><xsl:value-of select="$class"/></xsl:attribute>
    </xsl:if>
      <xsl:attribute name="href"><xsl:value-of select="$uris/uri[@id = current()/identifier[@type='id']]"/></xsl:attribute>
    <xsl:value-of select="title"/>
  </a>
  </xsl:when>
  <xsl:otherwise>
  <span>
    <xsl:if test="$class != ''">
      <xsl:attribute name="class"><xsl:value-of select="$class"/></xsl:attribute>
    </xsl:if>
    <xsl:value-of select="title"/>
  </span>
  </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="*" mode="navbar">
  <xsl:variable name="curr-sitemap"><xsl:copy-of select="$sitemap/root/page[descendant-or-self::page/@ref = $id]"/><xsl:if test="not($sitemap/root/page[descendant-or-self::page/@ref = $id])"><xsl:copy-of select="$sitemap/root/page[2]"/></xsl:if></xsl:variable>
  <div class="navbar">
    <div>
    <xsl:apply-templates select="$curr-sitemap/page" mode="horizontal-nav"/>
    <xsl:if test="$curr-sitemap/page/page"><xsl:text> | </xsl:text></xsl:if>
    <xsl:apply-templates select="$curr-sitemap/page/page" mode="horizontal-nav"/>
    </div>
  </div>
</xsl:template>

</xsl:stylesheet>