<?xml version="1.0" encoding="iso-8859-1" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="iso-8859-1" indent="no" method="xhtml" omit-xml-declaration="yes"/>

<xsl:param name="xdb-path"/>

<xsl:include href="meta.xsl"/>
<xsl:include href="common.xsl"/>
<xsl:include href="xdb.xsl"/>

<xsl:template match="/">
<xsl:if test="xpml/meta/format='application/x-httpd-php'">
  <xsl:processing-instruction name="php">session_start();</xsl:processing-instruction>
</xsl:if>
<xsl:apply-templates select="xpml/resource[position = 'header']"/>
<xsl:if test="xpml/meta/format='application/x-httpd-php'">
  <xsl:call-template name="xdb"/>
</xsl:if>
<xsl:text disable-output-escaping="yes">&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "/_dtd/xhtml1-transitional.dtd"></xsl:text>
<html xml:lang="{xpml/meta/language}" lang="{xpml/meta/language}">
 <head>
  <xsl:apply-templates select="/xpml/meta">
    <xsl:with-param name="style" select="'/_styles/site.css'"/>
  </xsl:apply-templates>
 </head>
<body>
  <xsl:if test="not($publishing = 1)"><script type="text/javascript" charset="iso-8859-1" src="/dav/menu.js"></script></xsl:if>
  <xsl:apply-templates select="xpml/meta/identifier[@type='id']" mode="header"/>
    <div id="body">
      <xsl:apply-templates mode="navcontext" select="xpml"/>
      <div id="content">
        <div id="navbar">
          <xsl:apply-templates select="xpml/resource[position = 'navbar']"/>
          <br /><br />
          <p><a href="http://sourceforge.net"><img src="http://sourceforge.net/sflogo.php?group_id=131811&amp;type=1" width="88" height="31" border="0" alt="SourceForge.net Logo" /></a></p>
        </div>
        <div id="default">
          <xsl:apply-templates select="xpml/resource[position = 'default' or position = 'col1' or position = 'col2']"/>
        </div>
        <br style="clear:both;" />
      </div>
    </div>
    <div id="footer">
      <p><xsl:apply-templates select="$sitemap//root/page[descendant-or-self::page/@ref = $id]/page" mode="horizontal-nav" /></p>
      <div id="copyright"><p>copyright  2005 tecnodesign</p></div>
    </div>
 </body>    
</html>
</xsl:template>
</xsl:stylesheet>